/*
 *  ԊORM|M
 *  2008/09-
 *
 *
 *
 *                         atmega88
 *               (RESET)PC6 1   28 PC5(ADC5/SCL)    24LC256/24LC64(4.7K PULL-UP)
 * RXD             (RXD)PD0 2   27 PC4(ADC4/SDA)    24LC256/24LC64(4.7K PULL-UP)
 * TXD             (TXD)PD1 3   26 PC3(ADC3)        IN#3
 * IR-IN                PD2 4   25 PC2(ADC2)        IN#2
 *                (OC2B)PD3 5   24 PC1(ADC1)        IN#1
 *                      PD4 6   23 PC0(ADC0)        IN#0
 *                      VCC 7   22 GND
 *                      GND 8   21 AREF
 * 8MHz          (XTAL1)PB6 9   20 AVCC
 * ZbN    (XTAL2)PB7 10  19 PB5(SCK)         PAGE LED#1(RED)
 * IR-SEND        (OC0B)PD5 11  18 PB4(MISO)        PAGE LED#0(GREEN)
 *          (OC0A)(AIN0)PD6 12  17 PB3(MOSI/OC2A)   OUT#3
 *                (AIN1)PD7 13  16 PB2(OC1B)        OUT#2
 * OUT#0                PB0 14  15 PB1(OC1A)        OUT#1
 *
uIWi[hv
    PC        Device
 --- IRM ---
    R    ->       IRM҂
        <-    Y   IRM҂
  [ c    ->       LZ
        <-    C ] LZ
        <-    S   
        <-  data  sampling-time(1byte)+length(2byteʁAʂ̏)+data(length)
        <-    E   
 --- IRM ---
    S    ->       IRMw
        <-    Y   IRMw
   data  ->       IRMf[^(IRMl̃f[^)
        <-    E   IRM
 --- TvOԊu ---
    T    ->       
        <-    Y   
   time  ->       1byte:15uS-200uS(default:100uS)
        <-    E   
 --- MJn ---
    N    ->       
        <-    Y   
   times ->       1byte:2-255(default:4)
        <-    E   
 --- ̓[h ---
    A    ->       ̓[hJnw
        <-    A/a A:̓[hʒmAa:̓[hʒm
 --- |[g ---
    I    ->       
        <-    Y   
        <-   data bit7-4:portb3-0,bit3-0:portc3-0
        <-    E   
 --- |[go ---
    O    ->       
        <-    Y   
   data  ->       data bit3-0:portb3-0
        <-    E   
 --- EEPROM ---
    E    ->       EEPROMANZXJn
        <-    E   Jnw
  [ c    ->       LZ
        <-    C ] LZ
    w    ->       EEPROM
   data  ->       AAAA LL BB CC DD SS
        <-    w   ݏI
    W    ->       OEEPROM
   data  ->       AAAA LL BB CC DD SS
        <-    W   ݏI
    r    ->       EEPROMǂݏo
   data  ->       AAAA LL
        <-    r   ǂݏoJn
        <-   data LL BB CC DD SS
        <-    E   ǂݏoI
    R    ->       OEEPROMǂݏo
   data  ->       AAAA LL
        <-    R   ǂݏoJn
        <-   data LL BB CC DD SS
        <-    E   ǂݏoI

ukuro-rs݊[hv
    PC        Device
 --- IRM ---
    r    ->       IRM҂
        <-    Y   IRM҂
  [ c    ->       LZ
        <-    C ] LZ
        <-    S   
        <-  data  IRMf[^(240byte)
        <-    E   
 --- IRM ---
    t    ->       IRMw
        <-    Y   IRMw
   (x)   ->       MfoCXԍ
        <-    Y   MfoCXԍ
   data  ->       IRMf[^(240byte)
        <-    E   IRM
 --- LED_ ---
    i    ->       
        <-    O   

 */
#include <stdint.h>
#include <stdlib.h>
#include <ctype.h>

#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <avr/wdt.h>
#if defined(__AVR_ATmega328P__)
#include "irio328.h"
#else
#include "irio88.h"
#endif


#if defined(__AVR_ATmega48__) || defined(__AVR_ATmega88__) ||\
    defined(__AVR_ATmega168__) || defined(__AVR_ATmega328P__)
/* map ATmega8/16 names to ATmegaX8 names */
#  define USART_RXC_vect USART_RX_vect
#  define UDR     UDR0
#  define UCSRA   UCSR0A
#  define UCSRB   UCSR0B
#  define FE      FE0
#  define TXEN    TXEN0
#  define RXEN    RXEN0
#  define RXCIE   RXCIE0
#  define UDRE    UDRE0
#  define U2X     U2X0
#  define UBRRH   UBRR0H
#  define UBRRL   UBRR0L

#  define TIMSK   TIMSK1
#  define MCUCSR  MCUSR
#endif


#define sbi(PORT,BIT) PORT|=_BV(BIT) // PORT̎wBIT1Zbg
#define cbi(PORT,BIT) PORT&=~_BV(BIT) // PORT̎wBITNA


// 20MHz NX^̏ꍇɒ`B`8MHzNX^
//#define	X20M

// PC3ADRo[^͂Ƃꍇɒ`
#define	ADC_ON

// F_CPUMakefileŒ`
// #define	F_CPU		8000000UL	/* CPU clock in Hz */
// #define	RS_BAUD		 57600UL		// SilentCp
#define	RS_BAUD		115200UL	// obt@[݊
//#define	VERSION		0x10			// Ver.1 &  ---(EEPROM)
//#define	VERSION		0x11			// Ver.1 &  64K(EEPROM)
#define	VERSION		0x12			// Ver.1 & 256K(EEPROM)

#ifdef	ADC_ON
#define ADC_ENABLE (_BV(ADEN)|_BV(ADIF)|0b111)
#define ADC_START  (ADC_ENABLE|_BV(ADSC))
#endif

#define	IR_INT	(F_CPU/8/38200-1)	// 38.2KHz
#define	IR_ON	IR_INT*2/3			// duty 1/3
#define	IR_OFF	IR_INT+1			// Over IR_INT


#define	SMP_uS(us)	((F_CPU/8/10000*us)/100-1)	// mFJEglvZ

#ifdef	X20M
#define	TIME_INT01	(int16_t)(65535-(F_CPU/1024)+1)	// 1bvp
#else
#define	TIME_INT01	(int16_t)(65535-(F_CPU/256)+1)	// 1bvp
#endif


uint8_t	EEPROM_read(uint16_t uiAddress);
static	void	EEPROM_write(uint16_t uiAddress, uint8_t ucData);
void	EepromExe(void);


volatile struct
{
	uint8_t	rx_int: 1;
	uint8_t	rec_start: 1;
	uint8_t	send_start: 1;
	uint8_t	analyze: 1;
	uint8_t	timer_mode: 1;
	uint8_t	time_set: 1;
	uint8_t	enable_rs_char: 1;
	uint8_t	clock_up: 1;
}
intflags;

#define	IR_DATA	930		/* 960->930 A[֘Aǉɔ */

#define	TIMER_EVENT	2000

#define	LED_RED_ON()	cbi( PORTB, PB5 )
#define	LED_RED_OFF()	sbi( PORTB, PB5 )
#define	LED_RED_STAT()	(PORTB & PB5)
#define	LED_GREEN_ON()	cbi( PORTB, PB4 )
#define	LED_GREEN_OFF()	sbi( PORTB, PB4 )

volatile	uint8_t		ir_bit;
volatile	uint8_t		ir_data[IR_DATA];

/* ԊOMȊOŗp郏[NGA(M̕ϐƋp) */
#define	WK1	ir_data[IR_DATA-1]
#define	WK2	ir_data[IR_DATA-2]
#define	WK3	ir_data[IR_DATA-3]
#define	WK4	ir_data[IR_DATA-4]
#define	WK5	ir_data[IR_DATA-5]
#define	WK6	ir_data[IR_DATA-6]
#define	WK7	ir_data[IR_DATA-7]
#define	WK8	ir_data[IR_DATA-8]

/* ȃ̂߁Aꕔ̕ϐWX^ϐ */
/* ȏヌWX^Ɋ蓖ĂƓs */
#if 0
volatile	uint8_t		loop;
volatile	uint16_t	i16;
volatile	uint16_t	i16_send_max;
volatile	uint16_t	i16_bit_count;
#else
register	uint8_t		loop			asm("r11");	/* [vJE^ */
register	uint16_t	i16				asm("r12");	/* ԊOpJE^ */
register	uint16_t	i16_send_max	asm("r14");	/* ԊOpJE^ */
register	uint16_t	i16_bit_count	asm("r16");	/* ԊOpJE^ */
#endif

volatile	uint8_t		smp_rate;	/* TvO[g */
volatile	uint8_t		rxbuff;		/* RS232CMobt@ */
volatile	uint8_t		smp_time;	/* TvO */
volatile	uint8_t		rec_check, rec_check_set;	/* ԊOMmFp */
volatile	uint8_t		eedata;		/* EEPROMf[^Ȃ[N */

#define	SETBUF_MAX	8
volatile	uint8_t		setbuf[SETBUF_MAX];	/* ԊOR[hf[^ */
volatile	uint8_t		page;		/* y[W */
volatile	uint8_t		gwk1;		/* O[o[Nϐ */
volatile	uint8_t		gwk2;		/* O[o[Nϐ */
volatile	uint8_t		gwk3;		/* O[o[Nϐ */
volatile	uint8_t		gwk_exe;	/* O[oaliassp */

volatile	uint8_t		t_wh, t_ms, t_ss;	/* ϐ */
volatile	uint8_t		t_timer;	/* 3bit^C}[pAʂXe[^XǗ */

#define	TIMER_MAX	5
volatile	uint8_t		tim_H[TIMER_MAX];		/* ^C}[p */
volatile	uint8_t		tim_L[TIMER_MAX];		/* ^C}[p */
volatile	uint8_t		tim_alias[TIMER_MAX];	/* ^C}[p */


#define	ADRS_SYS	0	/* 1byte:Alias,System(RS232C SPEED etc\) */
#define	ADRS_CTRL	5	/* 2byte:Rg[R[h */
uint8_t	ee_code_H[3], ee_code_L[3];

ISR(TIMER2_COMPA_vect)
//ISR(TIMER2_OVF_vect)
{
	if( intflags.rec_start ) {
		/* M */
		if( !(PIND & _BV(2)) ) {
			ir_data[i16] |= ir_bit;
		}
		ir_bit <<= 1;
		if( ir_bit == 0 ) {
			ir_bit = _BV(0);
			i16++;
			if( i16 >= IR_DATA ) {
				intflags.rec_start = 0;
			}
		}
	} else if( intflags.send_start ) {
		/* M */
		if( ir_data[i16]&ir_bit ) {
			OCR0B = IR_ON;
		} else {
			OCR0B = IR_OFF;
		}
		ir_bit <<= 1;
		if( ir_bit == 0 ) {
			ir_bit = _BV(0);
			i16++;
			if( i16 >= i16_send_max ) {
				intflags.send_start = 0;
			}
		}
	} else if( rec_check ) {
		/* MJnmF */
		if( !(PIND & _BV(2)) ) {
			ir_data[i16] |= ir_bit;
			ir_bit <<= 1;
			if( ir_bit == 0 ) {
				ir_bit = _BV(0);
				i16++;
			}
			if( rec_check == rec_check_set ) {
				/* Ď */
				OCR2A = smp_time;
				TCNT2 = 0;
			}
			rec_check--;
			if( rec_check == 0 ) {
			/* MJn */
				intflags.rec_start = 1;
			}
		} else {
			/* mCY */
			/* Ď𑁂߂ */
			OCR2A = 10;
			TCNT2 = 0;
			rec_check = rec_check_set;
			ir_bit = _BV(0);
			i16 = 0;
		}
	}
}

/* VAM荞 */
ISR(USART_RXC_vect)
{
	uint8_t c;

	c = UDR;
	if (bit_is_clear(UCSRA, FE)) {
		rxbuff = c;
		intflags.rx_int = 1;
	}
}

/* vpPb荞 */
ISR (SIG_OVERFLOW1)
{
	TCNT1 = TIME_INT01;

	t_ss++;
	if( t_ss == 15 ) {
		/* 15bɃJEgAbv */
		intflags.clock_up = 1;
		t_ss = 0;
		if( t_ms == 0xef ) {	/* 5945b:0xef */
			t_ms = 0;
			/* ʃoCǧグ */
			if( (t_wh&0x1f) == 23 ) {	/* 23 */
				t_wh &= 0xe0;
				t_wh += 0x20;
				if( t_wh == 0xe0 ) {
					t_wh = 0;
				}
			} else {
				t_wh++;
			}
		} else {
			t_ms++;
		}
	}
	if( t_timer&0x7 ) {
		t_timer--;
		if( !(t_timer&0x7) ) {
			/* ݒ^CAEg̏ꍇ */
			t_timer = 0xf8;
		}
	}
}

static	void	ee_port_init(void);	/* SCL=H */

/* I/O֘Ȁ */
static void
ioinit(void)
{
	DDRB = 0x3f;	// PORTB #0-#3,#4-#5(LED) output
	PORTB = 0x00;
	DDRC = 0x00;	// PORTC #0-#3 mode input & PULL-UP
	PORTC = 0x0f;
	DDRD = 0x20;	// PD5:OC0B output,PD4:MODE input,PD2:IR-REC input
	PORTD = 0x14;	// PD4,PD2:PULL-UP

	/* Set up the 8-bit timer 0. */
	TCCR0A = _BV(WGM01) | _BV(WGM00) | _BV(COM0B1) | _BV(COM0B0);
	TCCR0B = _BV(WGM02) | _BV(CS01);	/* clk/8 */
	OCR0A = IR_INT;	// for IR 38KHz
	OCR0B = IR_OFF;	// Over OCR0A

	/* Set up the 16-bit timer 1. */
#ifdef	X20M
	TCCR1B = _BV(CS12) | _BV(CS10);	/* clk/1024 */
#else
	TCCR1B = _BV(CS12);	/* clk/256 */
#endif
	TIMSK1 = _BV(TOIE1);
	t_ss = 0;
	t_ms = 0;
	t_wh = 0;

	/* Set up the 8-bit timer 2. */
	TCCR2A = _BV(WGM21);
	TCCR2B = _BV(CS21);	/* clk/8 */
	OCR2A = SMP_uS(100);	/* 100uS */
	TIMSK2 = _BV(OCIE2A);

	LED_RED_OFF();
	LED_GREEN_OFF();

	ee_port_init();

	UCSRA = _BV(U2X);
	UCSRB = _BV(TXEN)|_BV(RXEN)|_BV(RXCIE);	/* tx/rx enable, rx complete intr */
	UBRRH = 0;

#ifdef	ADC_ON
	ADCSRA = ADC_ENABLE;
	ADMUX  = 0b01100011;	// AREFS:01(AVCC) ADLAR:1 NC:0 MUX:0011(PC3)
//	DIDR0 |= 0x08;			// ADC3D=off
#endif

	sei();			/* enable interrupts */
}


static	void
putchr(char c)
{
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;
}

/* NEC/ƓdtH[}bg̉͏ */
static	void
AnaCode( void )
{
#define	BIT(n,bit)	(ir_data[n] & (1<<bit))
	uint8_t		bit, bit_out, data_out;
	uint8_t		stat;
	uint16_t	n, Head, H, L, base, base3;
	uint16_t	bit_count;

	H = 0;
	L = 0;
	Head = 0;
	stat = 0;
	base = 0;
	base3 = 0;
	bit_out = 7;
	data_out = 0;
	bit_count = 0;
	i16_bit_count = 0;
	for( n=0; n<i16_send_max; n++ ) {
		for( bit=0; bit<8; bit++ ) {
			if( stat == 2 ) {			/* Data read H */
				if( BIT(n,bit) ) {
					H++;
				} else {
					if( base == 0 ) {
						base = H + (H>>1);
						base3 = base + base + base;
						if( Head < base ) {
							return;
						}
					}
					stat++;
					L = 0;
				}
			} else if( stat == 3 ) {	/* Data read L */
				if( !BIT(n,bit) ) {
					L++;
					if( base3 < L ) {
						if( SETBUF_MAX < (bit_count>>3) ) {
							return;
						}
						setbuf[bit_count>>3] = data_out;
						i16_bit_count = bit_count;
						return;
					}
				} else {
					if( base < L ) {
						data_out |= (1<<bit_out);
					}
					if( bit_out == 0 ) {
						bit_out = 7;
						if( SETBUF_MAX < (bit_count>>3) ) {
							return;
						}
						setbuf[bit_count>>3] = data_out;
						data_out = 0;
					} else {
						bit_out--;
					}
					stat--;
					H = 0;
					bit_count++;
				}
			} else if( stat == 0 ) {	/* Header-H skip */
				if( BIT(n,bit) ) {
					H++;
				} else {
					Head = H>>2;
					H = 0;
					stat++;
				}
			} else if( stat == 1 ) {	/* Header-L skip */
				if( BIT(n,bit) ) {
					stat++;
				}
			}
		}
	}
	i16_bit_count = bit_count;
	return;
}

void	Led_OK(void)
{
	LED_GREEN_ON();
	_delay_ms(100);
	LED_GREEN_OFF();
}

void	Led_NG(void)
{
	WK7 = LED_RED_STAT();
	for( WK8=0; WK8<5; WK8++ ) {
		LED_RED_ON();
		_delay_ms(100);
		LED_RED_OFF();
		_delay_ms(100);
	}
	if( WK7 ) {
		LED_RED_ON();
	}
}

static	void	TimerEventExecute( void )
{
	/* ^C}[Cxg */
	WK1 = setbuf[0] | 0xe0;	/* p̔rf[^쐬 */
	for( loop=0; loop<TIMER_MAX; loop++ ) {
		if( (setbuf[0] == tim_H[loop] || WK1 == tim_H[loop]) && setbuf[1] == tim_L[loop] ) {
			/* v */
			/* alias񌟍 */
			for( WK2=0; WK2<EEPROM_read(0); WK2++ ) {
				WK3 = EEPROM_read(WK2*2+21);
				if( (tim_alias[loop]&0x7f) == (WK3&0x7f) ) {
					/* aliasv */
					i16 = (uint16_t)EEPROM_read(WK2*2+20);
					if( WK3 & 0x80 ) {
						i16 += 0x100;
					}
					/* Cxgǂݏo */
					eedata  = EEPROM_read(i16+2);
					if( tim_alias[loop] & 0x80 ) {
//putchr('t');
						/* ^C}[s */
						EepromExe();
						/* xs󂫂ɐݒ */
						tim_alias[loop] = 0;
					} else {
//putchr('a');
						/* A[s */
						if( intflags.timer_mode ) {
							/* ݒ肪sĂꍇ̂ݎs */
							EepromExe();
						}
					}
				}
			}
		}
	}
}

void	RecData( void )
{
	/* study mode */
	intflags.rec_start  = 0;
	rec_check  = 0;
	/* ̊荞݂lAQdݒ肷 */
	intflags.rec_start  = 0;
	rec_check  = 0;
	for( i16=0; i16<IR_DATA; i16++ ) {
		ir_data[i16] = 0;
	}
	ir_bit = _BV(2);
	i16 = 0;
	/* JnpɃTvOxAbv */
	OCR2A = 10;
	TCNT2 = 0;
	/* `FbNJn */
	rec_check = rec_check_set;
	for(;;) {
		/* LZ̑MmF */
		if( intflags.rx_int ) {
		/*	intflags.rx_int = 0; main()ŕԂ */
			if( rxbuff == 'c' ) {
				rec_check  = 0;
				intflags.rec_start  = 0;
				i16_send_max = 0;
		/*		putchr('Y'); main()ŕԂ */
				intflags.enable_rs_char = 1;
				return;
			} else if( intflags.enable_rs_char ) {
				rec_check  = 0;
				intflags.rec_start  = 0;
				i16_send_max = 0;
				intflags.enable_rs_char = 1;
				return;
			}
		}
		if( intflags.clock_up ) {
			/* Clock up(15bP) */
			if( !intflags.rec_start ) {
				/* MȂ̂ݎs */
				TimerEventExecute();
			}
		}
		if( t_timer == 0xf8 ) {
			/* ݒ^CAEg */
			/* KvȂ^CAEgɔy[W̏ */
			if( gwk3&0x0f ) {
				page = gwk3<<4;
				gwk3 = 0;
			}
			t_timer = 0;
			Led_NG();
		}
		/* ImF*/
		if( rec_check == 0 && intflags.rec_start == 0 ) {
			/* 蒆̊荞݂lAQd`FbN */
			if( rec_check == 0 && intflags.rec_start  == 0 ) {
				/* TvOI */
				/* ői[f[^vZ */
				for( i16_send_max=(IR_DATA-1); i16_send_max>=0; i16_send_max-- ) {
					if( ir_data[i16_send_max] ) {
						i16_send_max++;
						break;
					}
				}
				intflags.enable_rs_char = 1;
				return;
			}
		}
	}
}

/* EEPROM֐ */
/**********************************************************/
uint8_t EEPROM_read(uint16_t uiAddress)
{
	while(EECR & (1<<EEPE));
	EEAR = uiAddress;
	EECR |= (1<<EERE);
	return( EEDR );
}

static
void EEPROM_write(uint16_t uiAddress, uint8_t ucData)
{
	while(EECR & (1<<EEPE));
	EECR = (0<<EEPM1)|(0<<EEPM0);
	EEAR = uiAddress;
	EEDR = ucData;
	EECR |= (1<<EEMPE);
	EECR |= (1<<EEPE);
}
/**********************************************************/


/* OEEPROM֐ */
/**********************************************************/
#define	EE_WAIT_uS	3		/* 24LC256 400KHz(max)=2.5uS */
#define	EE_DEVICE	0
#define	SCL	PC5
#define	SDA	PC4
#define	EE_CHECK()	(PINC&_BV(SDA))

static	void
ee_port_init(void)	/* SCL=H */
{
	cbi( PORTC, SDA );
	cbi( DDRC, SDA );
	sbi( PORTC, SCL );
	sbi( DDRC, SCL );
}

void	ee_data_high(void)	/* SDA=H */
{
	/* ͏ԂƂ邱ƂɂhighƂ */
	cbi( DDRC, SDA );
	_delay_us(EE_WAIT_uS);
}

void	ee_data_low(void)	/* SDA=L */
{
	cbi( PORTC, SDA );
	sbi( DDRC, SDA );
	cbi( PORTC, SDA );	/* Ô */
	_delay_us(EE_WAIT_uS);
}

void	ee_clock_high(void)	/* SCL=H */
{
	sbi( PORTC, SCL );
	_delay_us(EE_WAIT_uS);
}

void	ee_clock_low(void)	/* SCL=L */
{
	cbi( PORTC, SCL );
	_delay_us(EE_WAIT_uS);
}

/**********************************************************/
void	start_condition(void)
{
	ee_data_high();		/* CLK=?  DAT=1 */
	ee_clock_high();	/* CLK=1  DAT=1 */
	ee_data_low();		/* CLK=1  DAT=0 */
	ee_clock_low();		/* CLK=0  DAT=0 */
}

void	stop_condition(void)
{
	ee_data_low();
	ee_clock_high();
	ee_data_high();
}

uint8_t	ee_write_data(uint8_t data)
{
	uint8_t	mask, ack;

	mask = 0x80;
	do {
		if( data & mask ) {
			ee_data_high();
		} else {
			ee_data_low();
		}
		ee_clock_high();
		ee_clock_low();
		mask = mask >> 1;
	} while( mask );
	ee_data_high();		/* SDA͂ɂ */
	ee_clock_high();	/* ACKpɃNbNhigh */
	if( EE_CHECK() ) {
		ack = 1;
	} else {
		ack = 0;
	}
	ee_clock_low();		/* ACK̃NbNI */
	ee_data_low();
	return(ack);
}

void	ee_start(void)
{
	uint8_t	ack;

	ee_data_high();
	ee_clock_high();

	do {
		start_condition();
		ack = ee_write_data( 0xa0+(EE_DEVICE<<1) );	/* 1010xxx0 ݎw */
	} while( ack != 0 );
}

uint8_t i2c_EEPROM_read(uint16_t uiAddress)
{
	uint8_t	mask, data;

	ee_start();	/* EEPROMANZXJn */

	ee_write_data(uiAddress>>8);		/* AhXʂWrbg */
	ee_write_data(uiAddress&0xff);	/* AhXʂWrbg */

	start_condition();

	ee_write_data( 0xa1+(EE_DEVICE<<1) );	/* 1010xxx1 ǂݍݎw */



	mask = 0x80;
	ee_data_high();		/* SDA̓[hɂ */
	data = 0;
	do {
		ee_clock_high();
		if( EE_CHECK() ) {
			data = data | mask;
		}
		ee_clock_low();
		mask = mask >> 1;
	} while( mask );
	ee_data_low();



	/* no ack */
	ee_data_high();
	ee_clock_high();
	ee_clock_low();
	ee_data_low();

	stop_condition();
	return(data);
}

static
void i2c_EEPROM_write(uint16_t uiAddress, uint8_t ucData)
{
	ee_start();	/* EEPROMANZXJn */

	ee_write_data(uiAddress>>8);	/* AhXʂWrbg */
	ee_write_data(uiAddress&0xff);	/* AhXʂWrbg */

	ee_write_data(ucData);
	stop_condition();
}
/**********************************************************/
uint8_t	alias_regist_check(uint8_t alias)
{
	uint8_t	cnt, n, dt;

	/* aliaso^Ăf[^mF */
	cnt = EEPROM_read(0);
	for( n=0; n<cnt; n++ ) {
		dt = EEPROM_read(n*2+21);
		if( alias == (dt&0x7f) ) {
			break;
		}
	}
	if( n == cnt ) {
		return(0);
	}
	return(1);
}

uint8_t	alias_free_check(void)
{
	uint8_t	n;

	for( n=0; n<TIMER_MAX; n++ ) {
		if( tim_alias[n] == 0 ) {
			/* 󂫃GA */
			return(n);
		}
	}
	return(0xff);
}

void	ReadEEHead(void)
{
	ee_code_H[0] = EEPROM_read(ADRS_CTRL);
	ee_code_L[0] = EEPROM_read(ADRS_CTRL+1);
	ee_code_H[1] = EEPROM_read(ADRS_CTRL+5);
	ee_code_L[1] = EEPROM_read(ADRS_CTRL+6);
	ee_code_H[2] = EEPROM_read(ADRS_CTRL+10);
	ee_code_L[2] = EEPROM_read(ADRS_CTRL+11);
}

void	EepromExe(void)
{
	/* ӁFWK1,WK2,WK3main()ŎgpAłWK4,WK5,WK6gp */
	switch( eedata&0xf ) {
	case	EV_SAMPLING:	/* Sampling */
		if( smp_rate == 100 ) {
			smp_rate = 150;
			Led_OK();
			_delay_ms(100);
		} else {
			smp_rate = 100;
		}
		Led_OK();
		smp_time = (uint8_t)SMP_uS(smp_rate);
		OCR2A = smp_time;
		break;
	case	EV_PORT:		/* PortOutput */
		eedata = EEPROM_read(i16+3);
		switch( eedata&0x3c ) {
		case	0x00:		/* toggle */
			if( PORTB & (1<<(eedata & 0x3)) ) {
				cbi( PORTB, eedata & 0x3 );
			} else {
				sbi( PORTB, eedata & 0x3 );
			}
			break;
		case	0x04:		/* on */
			sbi( PORTB, eedata & 0x3 );
			break;
		case	0x08:		/* off */
			cbi( PORTB, eedata & 0x3 );
			break;
		case	0x0c:		/* toggle(c-on)  */
			if( (PINC & _BV(eedata & 0x3)) ) {
				if( PORTB & (1<<(eedata & 0x3)) ) {
					cbi( PORTB, eedata & 0x3 );
				} else {
					sbi( PORTB, eedata & 0x3 );
				}
			}
			break;
		case	0x10:		/* on(c-on)  */
			if( (PINC & _BV(eedata & 0x3)) ) {
				sbi( PORTB, eedata & 0x3 );
			}
			break;
		case	0x14:		/* off(c-on)  */
			if( (PINC & _BV(eedata & 0x3)) ) {
				cbi( PORTB, eedata & 0x3 );
			}
			break;
		case	0x18:		/* toggle(c-off)  */
			if( !(PINC & _BV(eedata & 0x3)) ) {
				if( PORTB & (1<<(eedata & 0x3)) ) {
					cbi( PORTB, eedata & 0x3 );
				} else {
					sbi( PORTB, eedata & 0x3 );
				}
			}
			break;
		case	0x1c:		/* on(c-off)  */
			if( !(PINC & _BV(eedata & 0x3)) ) {
				sbi( PORTB, eedata & 0x3 );
			}
			break;
		case	0x20:		/* off(c-off)  */
			if( !(PINC & _BV(eedata & 0x3)) ) {
				cbi( PORTB, eedata & 0x3 );
			}
			break;
		default:
			break;
		}
		Led_OK();
		break;
	case	EV_PAGE:		/* PageChange */
		eedata = EEPROM_read(i16+3);
		switch( eedata&0x7 ) {
		case	0:	page = 0x10;	break;
		case	1:	page = 0x20;	break;
		case	2:	page = 0x40;	break;
		case	3:	page = 0x80;	break;
		case	4:
			if( !(page&0x80) ) {
				page <<= 1;
			}
			break;
		case	5:
			if( !(page&0x10) ) {
				page >>= 1;
			}
			break;
		default:
			break;
		}
		eedata = page>>4;
		while( eedata ) {
			Led_OK();
			_delay_ms(100);
			eedata >>= 1;
		}
		break;
	case	EV_ADJUST:		/* TimeAdjust */
cli();
		if( t_ms&0x2 ) {
			t_ss = 14;
			t_ms |= 0x3;
			TCNT1 = 0xffff;
		} else {
			t_ss = 0;
			t_ms &= 0xfc;
			TCNT1 = TIME_INT01;
		}
sei();
		Led_OK();
		break;
	case	EV_ALARM_MODE:	/* AlarmOn/Off/Toggle */
		if( intflags.time_set ) {
			/* ݒ肪sĂꍇ */
			eedata = EEPROM_read(i16+3);
			switch( eedata&0x3 ) {
			case	0:	/* toggle */
				if( intflags.timer_mode ) {
					intflags.timer_mode = 0;
					LED_RED_OFF();
				} else {
					intflags.timer_mode = 1;
					LED_RED_ON();
				}
				break;
			case	1:	/* on */
				intflags.timer_mode = 1;
				LED_RED_ON();
				break;
			case	2:	/* off */
				intflags.timer_mode = 0;
				LED_RED_OFF();
				break;
			default:
				break;
			}
		} else {
			Led_NG();
		}
		break;
	case	EV_TIME:	/* Time */
		eedata = EEPROM_read(i16+3);
		if( eedata & 0x01 ) {
			/* jʗL */
			t_timer = 1<<3;
		} else {
			/* jʖ */
			t_timer = 2<<3;
			gwk1 = 0;
		}
		gwk3 = EEPROM_read(i16+4);	/* AD1(PageInfo) */
		if( gwk3&0xf0 ) {
			page = gwk3&0xf0;
		}
		Led_OK();
		break;
	case	EV_ALARM:	/* Alarm */
		eedata = EEPROM_read(i16+3);	/* ID2 */
		if( eedata & 0x02 ) {
			/* once */
			gwk3 = 0x80;
		} else {
			/* repeat */
			gwk3 = 0x00;
		}
		if( eedata & 0x01 ) {
			/* jʗL */
			t_timer = 10<<3;
		} else {
			/* jʖ */
			t_timer = 11<<3;
			gwk1 = 7<<5;
		}
		eedata = EEPROM_read(i16+4);	/* AD1(PageInfo) */
		if( eedata&0xf0 ) {
			page = eedata&0xf0;
		}
		gwk3 += eedata&0x0f;			/* Ĩy[WҔ */
		Led_OK();
		break;
	case	EV_TIMER:		/* Timer */
		t_timer = 20<<3;
		gwk3 = EEPROM_read(i16+4);	/* AD1(PageInfo) */
		if( gwk3&0xf0 ) {
			page = gwk3&0xf0;
		}
		Led_OK();
		break;
	case	EV_ALARM_RESET:	/* AlarmReset */
		t_timer = 25<<3;
		gwk3 = EEPROM_read(i16+4);	/* AD1(PageInfo) */
		if( gwk3&0xf0 ) {
			page = gwk3&0xf0;
		}
		Led_OK();
		break;
	case	EV_ALIAS:		/* Alias */
		eedata = EEPROM_read(i16+3);
		if( eedata == 0x00 ) {
			t_timer = 30<<3;
			gwk3 = EEPROM_read(i16+4);	/* AD1(PageInfo) */
			if( gwk3&0xf0 ) {
				page = gwk3&0xf0;
			}
		} else {
			/* ^C}[ɉĎs */
			t_timer = 0;
			gwk_exe = eedata;
		}
		Led_OK();
		break;
	case	EV_NUMBER:		/* Number */
		eedata = EEPROM_read(i16+3);
		eedata &= 0xf;
		WK5 = 1<<3;	/* JEgAbvp */
		WK6 = 1;	/* LEDp */
		switch( t_timer>>3 ) {
		case	1:	/* TimeSet:Week */
			if( eedata < 8 ) {
				gwk1 = eedata<<5;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	2:	/* TimeSet:H1 */
			if( eedata < 3 ) {
				gwk1 += eedata*10;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	3:	/* TimeSet:H2 */
			gwk1 += eedata;
			break;
		case	4:	/* TimeSet:M1 */
			if( eedata < 6 ) {
				gwk2 = eedata*10;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	5:	/* TimeSet:M2 */
			/* Ĩy[W񂪑ҔĂ畜A */
			if( gwk3&0x0f ) {
				page = gwk3<<4;
				gwk3 = 0;
			}
			gwk2 += eedata;
cli();
			t_ss = 0;
sei();
			t_wh = gwk1;
			t_ms = gwk2<<2;
			intflags.timer_mode = 1;
			intflags.time_set = 1;
			LED_RED_ON();
			t_timer = 0;
			WK6 = 2;	/* LEDp(ݒ芮) */
			break;
		case	10:	/* AlarmSet:Week */
			if( eedata < 8 ) {			/* 0-6:date,7:all */
				gwk1 = eedata<<5;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	11:	/* AlarmSet:H1 */
			if( eedata < 3 ) {
				gwk2 = eedata*10;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	12:	/* AlarmSet:H2 */
			gwk2 += eedata;
			if( gwk2 < 24 ) {
				gwk1 += gwk2;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	13:	/* AlarmSet:M1 */
			if( eedata < 6 ) {
				gwk2 = eedata*10;
			} else {
				WK6 = 0;	/* LEDp */
			}
			break;
		case	14:	/* AlarmSet:M2 */
			gwk2 += eedata;
			gwk2 <<= 2;
			break;
		case	15:	/* AlarmSet:alias */
			/* Ĩy[W񂪑ҔĂ畜A */
			if( gwk3&0x0f ) {
				page = gwk3<<4;
			}
			gwk3 &= 0xf0;
			gwk3 += eedata;
			WK6 = 0;	/* LEDp(Ō̊mFȂ̂NGɏĂ) */
			/* aliaso^Ăf[^mF */
			if( alias_regist_check(eedata) ) {
				/* aliaso^Ă */
				/* 󂫃GAT */
				WK4 = alias_free_check();
				if( WK4 != 0xff ) {
					/* 󂫃GAL */
					tim_H[WK4] = gwk1;
					tim_L[WK4] = gwk2;
					tim_alias[WK4] = gwk3;
					WK6 = 2;	/* LEDp(ݒ芮) */
				}
			}
			gwk3 = 0;
			t_timer = 0;
			break;
		case	20:	/* Timer:M1 */
			gwk1 = eedata*10;
			break;
		case	21:	/* Timer:M2 */
			gwk1 += eedata;
			break;
		case	22:	/* Timer:alias */
			WK6 = 0;	/* LEDp(Ō̊mFȂ̂NGɏĂ) */
			/* aliaso^Ăf[^mF */
			if( alias_regist_check(eedata) ) {
				/* aliaso^Ă */
				/* 󂫃GAT */
				WK4 = alias_free_check();
				if( WK4 != 0xff ) {
					/* 󂫃GAL */
					if( gwk1 != 0 ) {
cli();
						tim_H[WK4] = t_wh;
						tim_L[WK4] = t_ms;
sei();
						while( gwk1 ) {
							gwk1--;
							/* PZ */
							tim_L[WK4] += 4;
							if( (tim_L[WK4]&0xf0) == 0xf0 ) {
								/* 猅オ */
								tim_L[WK4] &= 3;
								tim_H[WK4]++;
								if( (tim_H[WK4]&0x18) == 0x18 ) {
									/* 猅オ */
									tim_H[WK4] += 8;
									if( tim_H[WK4] == 0xe0 ) {
										/* jXV */
										tim_H[WK4] = 0;
									}
								}
							}
						}
						tim_alias[WK4] = eedata | 0x80;	/* 0x80:Timer */
						WK6 = 2;	/* LEDp(ݒ芮) */
					}
				}
			}
			t_timer = 0;
			/* Ĩy[W񂪑ҔĂ畜A */
			if( gwk3&0x0f ) {
				page = gwk3<<4;
				gwk3 = 0;
			}
			break;
		case	25:	/* AlarmReset:alias */
			/* Ĩy[W񂪑ҔĂ畜A */
			if( gwk3&0x0f ) {
				page = gwk3<<4;
				gwk3 = 0;
			}
			gwk1 = eedata;
			for( WK4=0; WK4<TIMER_MAX; WK4++ ) {
				if( gwk1 == 0 || (tim_alias[WK4]&0x7f) == gwk1 ) {
					tim_alias[WK4] = 0;
				}
			}
			WK6 = 2;	/* LEDp(ݒ芮) */
			t_timer = 0;
			break;
		case	30:	/* Alias:alias */
			/* Ĩy[W񂪑ҔĂ畜A */
			if( gwk3&0x0f ) {
				page = gwk3<<4;
				gwk3 = 0;
			}
			/* ^C}[ɉĎs */
			gwk_exe = eedata;
			WK6 = 2;	/* LEDp(ݒ芮) */
			t_timer = 0;
			break;
		default:
			WK6 = 0;	/* LEDp */
			break;
		}
		if( WK6 ) {	/* LEDp */
cli();
			t_timer += WK5;
sei();
			Led_OK();
			if( WK6 == 2 ) {	/* LEDp */
				_delay_ms(100);
				Led_OK();
				_delay_ms(100);
				Led_OK();
			}
		} else {
			WK5 = 0;
			t_timer = 0;
			Led_NG();
		}
		break;
	case	EV_CONVERT:		/* Convert */
		eedata = EEPROM_read(i16+3);
		_delay_ms((eedata&0xf)<<4);
		/* EEPROMAhX擾 */
		i16_bit_count = EEPROM_read(i16+4);
		i16_bit_count = i16_bit_count<<8;
		i16_bit_count += EEPROM_read(i16+5);
		if( eedata & 0x10 ) {
			/* ϊo(int) */
			/* TvO[gݒ */
			smp_rate = EEPROM_read( i16_bit_count );
			i16_bit_count++;
			smp_time = (uint8_t)SMP_uS(smp_rate);
			OCR2A = smp_time;
			/* Mf[^ݒ */
			i16_send_max = EEPROM_read( i16_bit_count );
			i16_bit_count++;
			i16_send_max = i16_send_max<<8;
			i16_send_max += EEPROM_read( i16_bit_count );
			i16_bit_count++;
			for( i16=0; i16<i16_send_max; i16++ ) {
				ir_data[i16] = EEPROM_read( i16_bit_count );
				i16_bit_count++;
			}
		} else {
			/* ϊo(ext) */
			/* TvO[gݒ */
			smp_rate = i2c_EEPROM_read( i16_bit_count );
			i16_bit_count++;
			smp_time = (uint8_t)SMP_uS(smp_rate);
			OCR2A = smp_time;
			/* Mf[^ݒ */
			i16_send_max = i2c_EEPROM_read( i16_bit_count );
			i16_bit_count++;
			i16_send_max = i16_send_max<<8;
			i16_send_max += i2c_EEPROM_read( i16_bit_count );
			i16_bit_count++;
			for( i16=0; i16<i16_send_max; i16++ ) {
				ir_data[i16] = i2c_EEPROM_read( i16_bit_count );
				i16_bit_count++;
			}
		}
		/* send */
		i16 = 0;
		ir_bit = 0x2;
		TCNT2 = 0;
		intflags.send_start = 1;
		OCR0B = IR_ON;
		while( intflags.send_start ) {
			;
		}
		Led_OK();
		break;
	}
}

int
main(void)
{
	smp_rate = 100;		/* 100uS:ftHg */
	smp_time = (uint8_t)SMP_uS(smp_rate);
	rec_check = 0;
	rec_check_set = 4;

	UBRRL = (F_CPU / 8 / RS_BAUD);		/* 덷̊֌W-1Ɠ삵Ȃ */
//	UBRRL = (F_CPU / 8 / RS_BAUD) - 1;	/* ʏ͂ */
	intflags.rx_int = 0;
	intflags.rec_start = 0;
	intflags.send_start = 0;
	intflags.analyze = 0;
	intflags.timer_mode = 0;
	intflags.time_set = 0;
	intflags.enable_rs_char = 0;

	i16_send_max = 0;
	t_timer = 0;
	page = 0x10;	/* 0001---- */
	gwk3 = 0;		/* ^CAEg̃y[Wƕp */
	gwk_exe = 0;	/* O[oaliassp */

	ioinit();

	for( loop=0; loop<TIMER_MAX; loop++ ) {
		tim_alias[loop] = 0;
	}

	/* EEPROMOǂݏoēǂݏo񐔂}~ */
	ReadEEHead();

	/* smp_time set */
	intflags.enable_rs_char = 1;
	smp_time = (uint8_t)SMP_uS(smp_rate);

	for(;;) {
		/* MMVAM҂ */
		RecData();
		if( i16_send_max ) {
			/* Mf[^ */
			AnaCode();
			if( i16_bit_count >= 32 ) {	/* Œ32bitȏ̎Mf[^̂݊mF */
				/* M */
				/* Rg[R[ḧvmF */
//putchr(setbuf[0]);
//putchr(setbuf[1]);
				for( loop=0; loop<3; loop++ ) {
					if( setbuf[0] == ee_code_H[loop] && setbuf[1] == ee_code_L[loop] ) {
						break;
					}
				}
				if( loop != 3 ) {
					/* vRg[R[h̐擪AhXvZ */
					loop++;	/* 擪s5byte̓VXe\ */
					loop *= 5;
					/* f[^i[擾 */
					WK2 = EEPROM_read(loop+2);
// Rg[R[h̃`FbN݂̂Ƃďȗ
//					if( WK2 >= (512-20)/6 ) {
//						continue;	/* eepromf[^ُAݒ蓙 */
//					}
					/* f[^i[JnAhX擾 */
					i16 = (uint16_t)EEPROM_read(loop+3);
					i16 <<= 8;
					i16 += (uint16_t)EEPROM_read(loop+4);
					/* ftHgōs */
					for( loop=0; loop<WK2; loop++ ) {
						if( setbuf[2] == EEPROM_read(i16) ) {
							if( setbuf[3] == EEPROM_read(i16+1) ) {
								/* R[hv */
								/* y[WmF */
								eedata = EEPROM_read(i16+2);
								if( eedata & page ) {
									/* y[Wv */
									EepromExe();
									break;
								}
							}
						}
						i16 += 6;
					}
				}

				if( gwk_exe ) {
					/* alias񌟍 */
					for( WK2=0; WK2<EEPROM_read(0); WK2++ ) {
						WK3 = EEPROM_read(WK2*2+21);
						if( gwk_exe == (WK3&0x7f) ) {
							/* aliasv */
							i16 = (uint16_t)EEPROM_read(WK2*2+20);
							if( WK3 & 0x80 ) {
								i16 += 0x100;
							}
							/* Cxgǂݏo */
							eedata  = EEPROM_read(i16+2);
							if( eedata & page ) {
								/* y[Wv */
								EepromExe();
							}
						}
					}
					gwk_exe = 0;
				}

				/* [hɉ */
				if( intflags.analyze ) {
					/* ̓[h */
					i16_send_max = (i16_bit_count+7) >> 3;
					putchr( 'D' );
					putchr( i16_send_max );
					for( i16=0; i16<i16_send_max; i16++ ) {
						putchr( setbuf[i16] );
					}
					putchr('E');
				}
			} else {
				/* mCYƔfĎ኱̑҂ */
			/*	_delay_ms(20);	Ƃ肠sv */
			}
		}
		if( !intflags.rx_int ) {
			continue;
		}
		/* VAM */
		intflags.rx_int = 0;
		if( rxbuff == 'r' ) {
			/* kuro-rs */
			/* smp_time set */
			smp_time = (uint8_t)SMP_uS(100);

			/* MM҂ */
			intflags.enable_rs_char = 0;	/* LZȊO}~ */
			putchr('Y');
			RecData();
			smp_time = (uint8_t)SMP_uS(smp_rate);
			if( i16_send_max ) {
				/* f[^LiȊO̓LZj */
				putchr('S');
				for( i16=0; i16<240; i16++ ) {
					putchr(ir_data[i16]);
				}
				putchr('E');
			}

		} else if( rxbuff == 'R' ) {
			/* original */
			/* smp_time set */
			smp_time = (uint8_t)SMP_uS(smp_rate);

			/* MM҂ */
			intflags.enable_rs_char = 0;	/* LZȊO}~ */
			putchr('Y');
			RecData();
			if( i16_send_max ) {
				/* f[^LiȊO̓LZj */
				putchr('S');
				putchr(smp_rate);
				putchr(i16_send_max>>8);
				putchr(i16_send_max&0xff);
				for( i16=0; i16<i16_send_max; i16++ ) {
					putchr(ir_data[i16]);
				}
				putchr('E');
			}

		} else if( rxbuff == 'S' ) {
			/* original */
			putchr('Y');
			/* TvO[gM */
			while( !intflags.rx_int );
			intflags.rx_int = 0;
			smp_rate = rxbuff;
			smp_time = (uint8_t)SMP_uS(smp_rate);
			OCR2A = smp_time;
			/* Mf[^M */
			while( !intflags.rx_int );
			intflags.rx_int = 0;
			i16_send_max = (uint16_t)rxbuff;
			i16_send_max = i16_send_max << 8;
			while( !intflags.rx_int );
			intflags.rx_int = 0;
			i16_send_max += (uint16_t)rxbuff;
			if( i16_send_max <= IR_DATA && i16_send_max != 0 ) {
				for( i16=0; i16<i16_send_max; i16++ ) {
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					ir_data[i16] = rxbuff;
				}
				/* send */
				i16 = 0;
				ir_bit = 0x2;
				TCNT2 = 0;
				intflags.send_start = 1;
				OCR0B = IR_ON;
				while( intflags.send_start ) {
					;
				}
				putchr('E');
			}
		} else if( rxbuff == 't' ) {
			/* kuro-rs */
			/* smp_time set */
			smp_time = (uint8_t)SMP_uS(100);
			/* study mode */
			intflags.rec_start  = 0;
			rec_check  = 0;
			/* ̊荞݂lAQdݒ肷 */
			intflags.rec_start  = 0;
			putchr('Y');
			/* ch receive */
			while( !intflags.rx_int );
			intflags.rx_int = 0;
			putchr('Y');
			/* data receive */
			for( i16=0; i16<240; i16++ ) {
				while( !intflags.rx_int );
				intflags.rx_int = 0;
				ir_data[i16] = rxbuff;
			}
			/* send */
			i16 = 0;
			ir_bit = 0x2;
			TCNT2 = 0;
			intflags.send_start = 1;
			OCR0B = IR_ON;
			while( intflags.send_start ) {
				;
			}
			putchr('E');
		} else if( rxbuff == 'T' ) {
			/* clock tick */
			putchr('Y');
			while( !intflags.rx_int );
			intflags.rx_int = 0;
#ifdef	X20M
			if( rxbuff >= 15 && rxbuff <= 100 ) {
#else
			if( rxbuff >= 15 && rxbuff <= 200 ) {
#endif
				smp_rate = rxbuff;
				smp_time = (uint8_t)SMP_uS(smp_rate);
				OCR2A = smp_time;
				putchr('E');
			}
		} else if( rxbuff == 'N' ) {
			/* n times */
			putchr('Y');
			while( !intflags.rx_int );
			intflags.rx_int = 0;
			if( rxbuff >= 2 ) {
				rec_check_set = rxbuff;
				putchr('E');
			}
		} else if( rxbuff == 'i' ) {	/* ݊[hp */
			Led_OK();
			putchr('O');
		} else if( rxbuff == 'A' ) {
			if( intflags.analyze ) {
				intflags.analyze = 0;
				putchr('a');
			} else {
				intflags.analyze = 1;
				putchr('A');
			}
		} else if( rxbuff == 'E' ) {
			/* EE read/write */
			putchr('E');
			for(;;) {
				/* Read/Write[hM */
				while( !intflags.rx_int );
				intflags.rx_int = 0;

				if( rxbuff == 'w' ) {
					/* f[^AhXM */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max = rxbuff;
					i16_send_max <<= 8;
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max += rxbuff;
					/* f[^M */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					ir_data[10] = rxbuff;
					/* f[^M */
					for( loop=0; loop < ir_data[10]; loop++ ) {
						while( !intflags.rx_int );
						intflags.rx_int = 0;
						ir_data[loop+12] = rxbuff;
					}
cli();	/* 荞݂֎~Ċ荞݃[`̃gp}~ݎs\h */
					for( loop=0; loop < ir_data[10]; loop++ ) {
						if( ir_data[loop+12] != EEPROM_read(i16_send_max) ) {
							EEPROM_write( i16_send_max, ir_data[loop+12] );
						}
						i16_send_max++;
					}
sei();
					putchr('w');
				} else if( rxbuff == 'r' ) {
					/* f[^AhXM */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max = rxbuff;
					i16_send_max <<= 8;
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max += rxbuff;
					/* f[^M */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					ir_data[10] = rxbuff;
					putchr('r');
					/* f[^M */
					putchr(ir_data[10]);
					/* f[^M */
					for( loop=0; loop < ir_data[10]; loop++ ) {
						putchr( EEPROM_read(i16_send_max) );
						i16_send_max++;
					}
					putchr('E');
				} else if( rxbuff == 'W' ) {
					/* f[^AhXM */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max = rxbuff;
					i16_send_max <<= 8;
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max += rxbuff;
					/* f[^M */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					ir_data[10] = rxbuff;
					/* f[^M */
					for( loop=0; loop < ir_data[10]; loop++ ) {
						while( !intflags.rx_int );
						intflags.rx_int = 0;
						ir_data[loop+12] = rxbuff;
					}
cli();	/* 荞݂֎~Ċ荞݃[`̃gp}~ݎs\h */
					for( loop=0; loop < ir_data[10]; loop++ ) {
						if( ir_data[loop+12] != i2c_EEPROM_read( i16_send_max ) ) {
							i2c_EEPROM_write( i16_send_max, ir_data[loop+12] );
						}
						i16_send_max++;
					}
sei();
					putchr('W');
				} else if( rxbuff == 'R' ) {
					/* f[^AhXM */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max = rxbuff;
					i16_send_max <<= 8;
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					i16_send_max += rxbuff;
					/* f[^M */
					while( !intflags.rx_int );
					intflags.rx_int = 0;
					ir_data[10] = rxbuff;
					putchr('R');
					/* f[^M */
					putchr(ir_data[10]);
					/* f[^M */
					for( loop=0; loop < ir_data[10]; loop++ ) {
						putchr( i2c_EEPROM_read( i16_send_max ) );
						i16_send_max++;
					}
					putchr('E');
				} else if( rxbuff == 'c' ) {
					putchr('Y');
					break;
				} else {
					/* ʑuڑ̂߂ƔfĂQbȂ */
					_delay_ms(2000);
					break;
				}
			}
			/* EEPROMXV */
			ReadEEHead();

		} else if( rxbuff == 'I' ) {	/* |[g */
			putchr('Y');
			putchr(VERSION);
			putchr((PORTB<<4)|(PINC&0xf));
#ifdef	ADC_ON
			ADCSRA = ADC_START;		//ϊJn
			loop_until_bit_is_set(ADCSRA,ADIF);	//ϊIADIFZbg
			ADCSRA = ADC_ENABLE;	//ADIF̃NA.̏ꍇ͂ȂĂ
			putchr(ADCL);
			putchr(ADCH);
#endif
			putchr('E');

		} else if( rxbuff == 'O' ) {	/* |[go */
			putchr('Y');
			while( !intflags.rx_int );
			intflags.rx_int = 0;
			if( rxbuff&0x01 ) {
				sbi( PORTB, PB0 );
			} else {
				cbi( PORTB, PB0 );
			}
			if( rxbuff&0x02 ) {
				sbi( PORTB, PB1 );
			} else {
				cbi( PORTB, PB1 );
			}
			if( rxbuff&0x04) {
				sbi( PORTB, PB2 );
			} else {
				cbi( PORTB, PB2 );
			}
			if( rxbuff&0x08 ) {
				sbi( PORTB, PB3 );
			} else {
				cbi( PORTB, PB3 );
			}
			putchr('E');

		} else if( rxbuff == 'c' ) {
			putchr('Y');
		}

	}
}
