#ifdef	WINDOWS
#include	<windows.h>
#include	<conio.h>
#include	<io.h>
#endif
#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>
#include	<ctype.h>
#include	<time.h>
#include	<errno.h>
#include	"erslib.h"
#include	"comwin.h"
#include	"irio88.h"


char	*DataFile = NULL;
int		ComPort = -1;
int		TcpPort = -1;
int		Mode;	/* 0:send,1:receive,2:view,3:inport,4:send(NEC),5:eeprom */
char	*Server = NULL;
int		Debug = 0;

int	ViewCode( int len, unsigned char *buf, int set_max, unsigned char *setbuf );

void MessageLog(char *msg)
{
	printf( "%s\n", msg );
}

int		tcp_connect(char *host, int port)
{
	struct	hostent	*servhost;
	struct	sockaddr_in	server;
	struct	servent	*sp;
	int		fh;
	int		addr[4];
	char	*p, buff[100];
	unsigned	char	ip[4];

	memset( (char *)&server, 0, sizeof(server) );
	server.sin_family = AF_INET;

	if( isdigit(*host) ) {
		/* zXghoAhXɂȂĂ */
#ifdef	WINDOWS
		server.sin_addr.s_addr = inet_addr( host ); 
		if( server.sin_addr.s_addr == INADDR_NONE ){ 
			MessageLog( "inet_addr() open error!" );
			return(-1);
		}
#else
		if(!inet_aton(host, (char *)&server.sin_addr)) {
			MessageLog( "inet_aton() open error!" );
		}
#endif
	} else {
		/* zXĝhoAhX擾 */
		if( (servhost=gethostbyname(host)) == NULL ) {
			MessageLog( "gethostbyname() open error!" );
			return(-1);
		}
		memcpy( (char *)&server.sin_addr, servhost->h_addr, (int)sizeof(struct in_addr) );
	}
	server.sin_port = htons((short)port);
	if( (fh=socket(AF_INET,SOCK_STREAM,0))<0 ) {
		MessageLog( "socket() open error!" );
		return(-1);
	}
	if( connect( fh, (struct sockaddr *)&server, sizeof(struct sockaddr) )<0 ) {
		close( fh );
		MessageLog( "connect() open error!" );
		return(-1);
	}
	return( fh );
}

int	tcp_data_length(int fh, int *length)
{
	if( fh == -1 ) {
		return(-1);
	}
#ifdef WINDOWS
	ioctlsocket( fh, FIONREAD, (unsigned long *)length );
#else
	if( ioctl( fh, FIONREAD, (unsigned long *)length ) == -1 ) {
		MessageLog( "ioctl() open error!" );
		return(-1);
	}
#endif
	return(0);
}

int	tcp_send(int fh, char *data, int length)
{
	int		rc;

	if( fh == -1 ) {
		return(-1);
	}
	rc = send( fh, data, length, 0 );
	if( rc != length ) {
		return(-1);
	}
	return(0);
}

int	tcp_rec(int fh, char *data, int length)
{
	int		i, j;

	if( fh == -1 ) {
		return(-1);
	}
	if( (i = recv( fh, data, length, 0 )) == -1 ) {
		return(-1);
	} else if( i < length ) {
		for( ; i<length; ) {
			if( (j = recv( fh, data+i, length-i, 0 )) == -1 ) {
				return(-1);
			}
			i += j;
		}
	}
	return(0);
}

int	tcp_disconnect(int fh)
{
	int		i, len;
	char	buf[256];

	if( fh != -1 ) {
		for( ;; ) {
			if( tcp_data_length( fh, &len ) == -1 ) {
				break;
			}
			if( len <= 0 ) {
				break;
			}
			for( i=0; i<len; i++ ) {
				if( tcp_rec( fh, (char *)buf, 1 ) != 0 ) {
					shutdown( fh, 2 );
					close( fh );
					fh = -1;
					return( fh );
				}
			}
		}
		shutdown( fh, 2 );
		close( fh );
		fh = -1;
	}
	return( fh );
}




/* NCAg̐ڑ҂T[ȍ\\ */
typedef struct {
    int                 wait_socket;    /* T[o҂󂯗p\Pbg */
    struct sockaddr_in  server_addr;    /* T[o҂󂯗pAhX */
} TCPSERVER_INFO;

/* NCAgƂ̐ڑɊւۑ\ */
typedef struct {
    int                 data_socket;    /* NCAgƂ̒ʐMp\Pbg */
    struct sockaddr_in  client_addr;    /* NCAg̃AhX */
} TCPCLIENT_INFO;
#define SERVER_IP       0x00000000UL    /* T[op҂IP */
#define BUFFER_SIZE     5100            /* obt@oCg */




/* TCPSERVER_INFO\̂̏ */
void tcpserver_init(TCPSERVER_INFO* server_info,unsigned long ip,unsigned short port)
{
	memset(server_info, 0, sizeof(*server_info));

	/* socket()G[̂Ƃ-1ԂƂl-1Ə */
	/* G[tcpserver_close()Ń\PbgN[YȂ߂̍Hv */
	server_info->wait_socket = -1;

	/* IPAhXƃ|[gԍZbg */
	server_info->server_addr.sin_family     = AF_INET;      /* TCP/IP */
#if 0
	server_info->server_addr.sin_addr.s_addr= htonl(ip);    /* IPAhX */
#else
	server_info->server_addr.sin_addr.s_addr= ip;    /* IPAhX */
#endif
	server_info->server_addr.sin_port       = htons(port);  /* |[gԍ */
}

/* T[o҂󂯗p\Pbg̍쐬Eݒu */
/* Al 1: 0:G[ */
int tcpserver_open(TCPSERVER_INFO* server_info,int mode_wait)
{
#ifdef WINDOWS
	unsigned	long	param;
#else
	int on = 1;
#endif

	/* TCP\Pbg쐬 */
	server_info->wait_socket = socket(PF_INET, SOCK_STREAM, 0);
	if(server_info->wait_socket==-1) {
		/* \Pbg쐬̎s */
		perror("tcpserver_open.socket");
		return 0;
	}

	if( mode_wait ) {
#ifdef WINDOWS
		param = 1;
		ioctlsocket( server_info->wait_socket, FIONBIO, &param );
#else
		on = 1;
		if( ioctl(server_info->wait_socket,FIONBIO,(char *)&on) == -1 ) {
			perror("tcpserver_open.ioctl");
			return 0;
		}
#endif
	}

	/* TCP\Pbgݒu */
	/* ɂT[õ|[giNCAg҂󂯗pjL */
	/* ̂ƂTCP\Pbg̏Ԃ̓N[YiCLOSEjƂȂ */
	if(bind(server_info->wait_socket,
			(struct sockaddr*)&server_info->server_addr,
			sizeof(server_info->server_addr))==-1) {
		/* \Pbgݒu̎s - Ɉȉ2 */
		/* (1)|[gɎgpĂ */
		/* (2)|[gԍ1023ȉłɂւ炸ʃ[UŎs */
		perror("tcpserver_open.bind");
		return 0;
	}

	/* TCP\PbgNCAgڑ҂ԁiLISTENjɂ */
/*	if(listen(server_info->wait_socket, 5)==-1) {	*/
	if(listen(server_info->wait_socket,20)==-1) {
		/* ʂ͂ȂƂł͎sȂُH */
		perror("tcpserver_open.listen");
		return 0;
	}
	/* I */
	return 1;
}

/* T[o҂󂯗p\Pbg̊J */
void tcpserver_close(TCPSERVER_INFO* server_info)
{
	/* \PbgI[vĂȂN[Y */
	if(server_info->wait_socket != -1) {
		shutdown(server_info->wait_socket,2);
		close(server_info->wait_socket);
		server_info->wait_socket = -1;
	}
}

/* NCAg̐ڑҋ@Em */
/* Al 1:NCAgƂ̐ڑm 0:G[ */
int tcpserver_wait(TCPSERVER_INFO* server_info,TCPCLIENT_INFO* client_info,int mode_wait)
{
	/* client_info\̂ */
	memset(client_info, 0, sizeof(*client_info));   /* [NA */
	client_info->data_socket = -1;      /* accept()̃G[lŏ */

	/* NCAgڑҋ@Cڑꂽf[^p\Pbg擾 */
	/* for(;;)[v̓VOiMɍaccept()邽ߕKv */
	for(;;) {
#ifdef	WINDOWS
		int client_addr_len = sizeof(client_info->client_addr);
#else
		socklen_t client_addr_len = sizeof(client_info->client_addr);
#endif
		client_info->data_socket =
			accept(server_info->wait_socket,(struct sockaddr*)&client_info->client_addr,&client_addr_len);

		/* accept()̕Ԃl`FbN */
		if(client_info->data_socket!=-1) break; /* I */
		if(errno==EINTR) continue;              /* VOiMaccept() */
		if( !mode_wait ) {
			perror("tcpserver_open.accept");    /* ςG[ */
		}
		return 0;   /* G[I */
	}
	/* I */
	return 1;
}

/****************/
int	RsSendAndWait( int port, char *msg, int length, char waitchar, int waitms, FILE *closefp )
{
	int		n;
	char	buff[10];

	/* Mw */
	if( msg != NULL && length ) {
		if( ERS_Send( port, msg, length ) != 1 ) {
			if( closefp != NULL ) {
				fclose( closefp );
			}
			printf( "COM send() error.\n" );
			return(-1);
		}
	}

	for( n=waitms/50; n>0; n-- ) {
		if( ERS_CheckRecv( port ) > 0 ) {
			ERS_Recv( port, buff, 1 );
			if( *buff == waitchar ) {
				break;
			}
		}
		Sleep(50);
	}
	if( n == 0 ) {
		if( closefp != NULL ) {
			fclose( closefp );
		}
		printf( "Device is not ready.\n" );
		return(-1);
	}
	return(0);
}
int	RsRecAndWait( int port, int waitms )
{
	int		n;
	char	buff[10];

	for( n=waitms/50; n>0; n-- ) {
		if( ERS_CheckRecv( port ) > 0 ) {
			ERS_Recv( port, buff, 1 );
			return( *buff );
		}
		Sleep(50);
	}
	return(-1);
}
/****************/

int	BitWrite( unsigned char samp, unsigned char *p, int *blen, int onoff, int length )
{
	int		n, adr, bit, cnt;

	cnt = (length+(samp/2))/samp;	/* JԂvZ */

	adr = (*blen)/8;
	bit = (*blen)%8;				/* ݒ肷rbgʒuvZ */
	for( n=0; n<cnt; n++ ) {
		(*blen)++;					/* i[rbgXV */
		if( onoff ) {
			p[adr] |= (1<<bit);			/* ONݒ */
		}
		bit = (++bit)%8;			/* rbgʒuXV */
		if( bit==0 ) {
			adr++;
		}
	}
	return(0);
}

unsigned	char	hex2bin( char *str )
{
	unsigned	int	d;
	char	bf[3];

	strncpy( bf, str, 2 );
	bf[2] = 0;
	sscanf( bf, "%x", &d );
	return( (unsigned char)d );
}

/* f[^쐬 */
int	MakeCode2Data( unsigned char *dst, unsigned char samp, char *src )
{
	int		n, bit, len, blen, src_len;
	unsigned	char	*p, bf[256], buff[1024];


	/* \[Xf[^vZ */
	src_len = strlen(src)/2;

	/* 񂩂oCi */
	p = bf;
	while( *src ) {
		*p = hex2bin( src );
		p++;
		src += 2;
	}

	/* f[^쐬iwb_j */
	memset( buff, 0, sizeof(buff) );
	buff[0] = samp;
	p = &buff[3];
	blen = 0;
	BitWrite( samp, p, &blen, 1, 9030 );
	BitWrite( samp, p, &blen, 0, 4480 );

	/* f[^쐬 */
	for( n=0; n<src_len; n++ ) {
		for( bit=0; bit<8; bit++ ) {
			if( bf[n]&(1<<bit) ) {
				BitWrite( samp, p, &blen, 1, 560 );
				BitWrite( samp, p, &blen, 0, 1680 );
			} else {
				BitWrite( samp, p, &blen, 1, 560 );
				BitWrite( samp, p, &blen, 0, 560 );
			}
		}
	}

	/* f[^쐬iXgbvj */
	BitWrite( samp, p, &blen, 1, 560 );
	BitWrite( samp, p, &blen, 0, 560 );

	/* f[^쐬if[^j */
	len = (blen+7)/8;
	buff[1] = len/256;
	buff[2] = len%256;
	memcpy( dst, buff, len + 3 );
	return( len + 3 );
}

/* JX^ER[h 00XXH ͎̕RɎg */
int	DataSendNec( char *fname )
{
	int		n, bit, len, blen;
	int		dt;
	char	*src, *dst, bf0[256], bf1[256];
	unsigned	int		c, d, ccode, data;
	unsigned	char	uch, buff[1024], *p;
	FILE	*fp;

	if( (fp=fopen(fname,"rb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

	//Mobt@̃NA
	ERS_ClearRecv( ComPort );
	//Mobt@̃NA
	ERS_ClearSend( ComPort );

printf( "DataSend\n" );

	while( fgets( bf0, 256, fp ) != NULL ) {
		sscanf( bf0, "%s", bf1 );
		if( !isxdigit(*bf1) ) {
			continue;
		}
		src = bf1;
		dst = bf0;
		while( *src ) {
			if( !isxdigit(*src) ) {
				continue;
			}
			*dst = *src;
			dst++;
			src++;
		}
		*dst = 0;
		if( (strlen(bf0)%2) != 0 ) {
			continue;
		}
		printf( "[%s]\n", bf0 );
		len = MakeCode2Data( buff, 100, bf0 );

		/* Mw */
		if( RsSendAndWait( ComPort, "S", 1, 'Y', 2000, NULL ) != 0 ) {
			return(-1);
		}

		for( n=0; n<len; n++ ) {
			uch = (unsigned char)buff[n];
			if( ERS_Send( ComPort, &uch, 1 ) != 1 ) {
				printf( "COM send() error.\n" );
				return(-1);
			}
			Sleep(1);
		}

		if( RsSendAndWait( ComPort, NULL, 0, 'E', 2000, NULL ) != 0 ) {
			return(-1);
		}

		Sleep(30);

	}
	fclose( fp );
	return( 0 );
}

int	MakeDataFile( char *fname )
{
	int		len;
	char	*src, *dst, bf0[256], bf1[256];
	unsigned	char	buff[1024];
	FILE	*fp, *wfp;

	if( (fp=fopen(fname,"rb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

printf( "MakeDataFile\n" );

	while( fgets( bf0, 256, fp ) != NULL ) {
		sscanf( bf0, "%s", bf1 );
		if( !isxdigit(*bf1) ) {
			continue;
		}
		src = bf1;
		dst = bf0;
		while( *src ) {
			if( !isxdigit(*src) ) {
				continue;
			}
			*dst = *src;
			dst++;
			src++;
		}
		*dst = 0;
		if( (strlen(bf0)%2) != 0 ) {
			continue;
		}
		printf( "[%s]\n", bf0 );
		len = MakeCode2Data( buff, 100, bf0 );
		strcat( bf0, ".dat" );
		if( (wfp=fopen(bf0,"wb")) != NULL ) {
			fwrite( buff, 1, len, wfp );
			fclose(wfp);
		} else {
			printf( "File open error.[%s]\n", bf0 );
			break;
		}
	}
	fclose( fp );
	return( 0 );
}

int	DataSend( char *fname )
{
	int		n;
	int		dt;
	unsigned	char	uch, buf[10];
	FILE	*fp;

	if( (fp=fopen(fname,"rb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

	//Mobt@̃NA
	ERS_ClearRecv( ComPort );
	//Mobt@̃NA
	ERS_ClearSend( ComPort );

	/* Mw */
	if( RsSendAndWait( ComPort, "S", 1, 'Y', 2000, fp ) != 0 ) {
		return(-1);
	}

	/* f[^M */
	while( (dt=fgetc(fp)) != EOF ) {
		uch = (unsigned char)dt;
		if( ERS_Send( ComPort, &uch, 1 ) != 1 ) {
			fclose( fp );
			printf( "COM send() error.\n" );
			return(-1);
		}
		Sleep(1);
	}
	fclose( fp );

	if( RsSendAndWait( ComPort, NULL, 0, 'E', 2000, NULL ) != 0 ) {
		return(-1);
	}

	return(0);
}

int	DataReceive( char *fname )
{
	int		n;
	int		len;
	int		cnt;
	int		dt;
	FILE	*fp;
	unsigned	char	buf[10];

	if( (fp=fopen(fname,"wb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

	//Mobt@̃NA
	ERS_ClearRecv( ComPort );
	//Mobt@̃NA
	ERS_ClearSend( ComPort );

	/* Mw */
	if( RsSendAndWait( ComPort, "R", 1, 'Y', 2000, fp ) != 0 ) {
		return(-1);
	}

	printf( "Hit [ESC] to break.\n" );

	cnt = 0;
	for( n=600; n>0; n-- ) {
		if( kbhit() ) {
			dt = getch();
			if( dt == 0x1b ) {
				if( ERS_Send( ComPort, "c", 1 ) != 1 ) {
					fclose( fp );
					printf( "COM send() error.\n" );
					return(-1);
				}
				printf("Receive Cancel!\n");
				fclose( fp );
				return(0);
			}
		}

		if( ERS_CheckRecv( ComPort ) > 0 ) {
			ERS_Recv( ComPort, buf, 1 );
			if( cnt == 0 ) {
				if( *buf == 'S' ) {
					printf("Receive Start!\n");
					cnt++;
					continue;
				} else {
					n = 0;
					break;
				}
			}
			cnt++;
			if( cnt == 3 ) {
				len = (unsigned int)*buf;
				len <<= 8;
			} else if( cnt == 4 ) {
				len += (unsigned int)*buf;
			} else if( cnt > 4 ) {
				if( cnt >= (1+3+len+1) && *buf == 'E' ) {
					n = 600;
					break;
				}
			}
			fputc( *buf, fp );
			n = 600;
			continue;
		}
		Sleep(100);
	}
	if( n == 0 ) {
		fclose( fp );
		printf( "COM receive() timeout.\n" );
		return(-1);
	}
	fclose( fp );
	return(0);
}

long	fsize( char *fname )	/* t@CTCY𒲂ׂ */
{
	FILE	*fp;
	long	sz;

	if( (fp=fopen( fname, "r" )) == NULL ) {
		return( -1L );
	}
	fseek( fp, 0L, 2 );
	sz = ftell( fp );
	fclose( fp );
	return( sz );
}

static	FILE	*FileReadFp = NULL;
static	char	*FileReadName[256];
static	int		FileReadMax = 0, FileReadCnt = 0;

int	FileReadInit(char *filename[],char fname_flg[], int cnt)
{
	int		m, n;

	for( n=0, m=0; n<cnt; n++ ) {
		if( fname_flg[n] == 0 ) {
			FileReadName[m] = filename[n];
			m++;
		}
	}
	FileReadMax = m;
	FileReadCnt = 0;
	if( FileReadMax ) {
		FileReadFp = fopen(FileReadName[FileReadCnt],"rb");
		if( FileReadFp != NULL ) {
			FileReadCnt++;
			return(0);
		}
	}
	return(-1);
}

int	FileReadChar(void)
{
	int		dt;

	for( ;; ) {
		dt = fgetc(FileReadFp);
		if( dt < 0 ) {
			/* EOF */
			fclose( FileReadFp );
			FileReadFp = NULL;
			if( FileReadCnt == FileReadMax ) {
				return( -1 );
			}
			FileReadFp = fopen(FileReadName[FileReadCnt],"rb");
			if( FileReadFp != NULL ) {
				FileReadCnt++;
			} else {
				return( -1 );
			}
		} else {
			return( dt );
		}
	}
}

void	FileReadEnd(void)
{
	if( FileReadFp != NULL ) {
		fclose( FileReadFp );
		FileReadFp = NULL;
	}
}

/* gpFp~ */
int	time_conv( char *p, unsigned char *dst )	/* ->lϊ */
{
	char	bf[256];
	int		w, hh, mm, ss;

	w = 7;	/* all date */
	mm = 0;
	ss = 0;
	if( !isdigit(*p) ) {
		return(-1);
	}
	bf[0] = *p;
	bf[1] = 0;
	p++;
	if( isdigit(*p) ) {
		bf[1] = *p;
		bf[2] = 0;
		p++;
	}
	sscanf( bf, "%d", &hh );
	if( *p == ':' ) {
		p++;
	}
	if( *p != 0 ) {

		if( isdigit(*p) ) {
			bf[0] = *p;
			bf[1] = 0;
			p++;
			if( isdigit(*p) ) {
				bf[1] = *p;
				bf[2] = 0;
				p++;
			}
			sscanf( bf, "%d", &mm );
			if( *p == ':' ) {
				p++;
			}

			if( isdigit(*p) ) {
				bf[0] = *p;
				bf[1] = 0;
				p++;
				if( isdigit(*p) ) {
					bf[1] = *p;
					bf[2] = 0;
					p++;
				}
				sscanf( bf, "%d", &ss );
			}
		}
		if( *p != 0 ) {
			if( stricmp(p,"Sun") == 0 ) {
				w = 0;
			} else if( stricmp(p,"Mon") == 0 ) {
				w = 1;
			} else if( stricmp(p,"Tue") == 0 ) {
				w = 2;
			} else if( stricmp(p,"Wed") == 0 ) {
				w = 3;
			} else if( stricmp(p,"Thu") == 0 ) {
				w = 4;
			} else if( stricmp(p,"Fri") == 0 ) {
				w = 5;
			} else if( stricmp(p,"Sat") == 0 ) {
				w = 6;
			} else {
				return(-1);
			}
		}
	}

	/*       3           5            6              2 */
	/* 111(0-7) 11111(0-24) 111111(0-59) 11(0/15/30/45) */
	/* 0:Sun,6:Sat,7:All */
	dst[0] = (w<<5) | hh;
	dst[1] = (mm<<2) | (ss/15);
	return(0);
}

int	IrFile2Code( char *name, char *dst )
{
	FILE	*fp;
	int		dt, len, bit_count;
	char	buff[1024];

	if( (fp=fopen(name,"rb")) == NULL ) {
		printf( "File open error.\n" );
		printf( "> %s\n", name );
		return(-1);
	}
	fgetc(fp);		/* TvOx */
	fgetc(fp);		/* f[^(H) */
	fgetc(fp);		/* f[^(L) */
	len = 0;
	while( (dt=fgetc(fp)) >= 0 ) {
		buff[len] = (unsigned char)dt;
		len++;
	}
	bit_count = ViewCode( len, buff, 8, dst );
printf( "Reading [%s(%d)]\n", name, len );
	if( bit_count < 32 ) {
		fclose( fp );
		printf( "File format error.\n" );
		printf( "> %s\n", name );
		return(-1);
	}
	fclose( fp );
	return( bit_count );
}

int	PageGet( char *str )
{
	int	data = 0;

	if( toupper(*str) != 'P' ) {
		return(-1);
	}
	str++;
	while( *str ) {
		if( *str == '1' ) {
			data |= 0x01;
		} else if( *str == '2' ) {
			data |= 0x02;
		} else if( *str == '3' ) {
			data |= 0x04;
		} else if( *str == '4' ) {
			data |= 0x08;
		} else {
			return(-1);
		}
		str++;
	}
	if( data == 0 ) {
		return(-1);
	}
	return( data );
}

/* EEPROMւ̏f[^ */
int	EepromMode( char *fname )
{
#define	EEDATA_MAX	82		/* (512-20)/6 */
#define	ALIAS_MAX	9
	FILE	*fp;
	int		fcount, i, dt, rc, len, ch, mode, input_flg, page, wk1, wk2;
	int		use_int_rom, adr, new_adr, page_top, ext_int;
	int		bit_count, tmp_num, cnt_total;
	long	sz;
	int		code_cnt, data_cnt[3];
	char	buff[1024], buf2[10], buf3[10], bf[9][256];
	char	fname_flg[EEDATA_MAX], *target_file;
	char	fname_data[EEDATA_MAX][256+1], *fname_data_ptr[EEDATA_MAX];
	unsigned	char	ee_image[512];
	long	m, n;
	unsigned	long	ext_adr, int_adr;
	char	*msg = "";
	int		alias_num;
	unsigned	char	alias[128];

	for( n=0; n<EEDATA_MAX; n++ ) {
		fname_flg[n] = -1;
		fname_data_ptr[n] = fname_data[n];
	}
	code_cnt = 0;		/* codei[ */
	data_cnt[0] = 0;	/* datai[ */
	data_cnt[1] = 0;	/* datai[ */
	data_cnt[2] = 0;	/* datai[ */
	page_top = 20;		/* y[WgbvAhX */
	ext_adr = 0;		/* OEEPROMAhX */
	int_adr = 0;		/* EEPROMAhX */
	memset( ee_image, 0xff, sizeof(ee_image) );
	ee_image[0] = 0;	/* alias count */
	ee_image[0*5+5+2] = 0;
	ee_image[1*5+5+2] = 0;
	ee_image[2*5+5+2] = 0;
	cnt_total = 0;
	if( (fp=fopen(fname,"rb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}
	while( fgets( buff, 256, fp ) != NULL ) {
		if( !isalpha(*buff) ) {
			continue;
		}
		if( (ee_image[1*5+2]+ee_image[2*5+2]+ee_image[3*5+2]) > EEDATA_MAX ) {
			fclose( fp );
			printf( "Over flow.\n" );
			return(-1);
		}
		rc = sscanf( buff, "%s %s %s %s %s %s %s %s %s",
				bf[0], bf[1], bf[2], bf[3], bf[4], bf[5], bf[6], bf[7], bf[8] );
		if( rc >= 2 ) {
			bit_count = IrFile2Code( bf[1], buf2 );
			if( bit_count == -1 ) {
				fclose( fp );
				return(-1);
			}
		}
		if( stricmp( bf[0], "code" ) == 0 ) {
			/* code錾̏ */
			code_cnt++;
			if( code_cnt > 3 ) {
				fclose( fp );
				printf( "Code count overflow.(max=3)\n" );
				return(-1);
			}
			if( rc != 2 ) {
				fclose( fp );
				printf( "File format error.\n" );
				printf( "> %s", buff );
				return(-1);
			}
			/* 擪5byte̓VXeʗpr(_ł͖gp) */
			ee_image[code_cnt*5+0] = buf2[0];	/* code */
			ee_image[code_cnt*5+1] = buf2[1];
			ee_image[code_cnt*5+3] = page_top>>8;
			ee_image[code_cnt*5+4] = page_top&0xff;
		} else if( stricmp( bf[0], "data" ) == 0 ) {
			/* data錾̏ */
			if( code_cnt == 0 ) {
				fclose( fp );
				printf( "File format error.(code not found)\n" );
				return(-1);
			}
			if( rc < 3 ) {	/* ǂȃf[^łŒR */
				fclose( fp );
				printf( "File format error.\n" );
				printf( "> %s", buff );
				return(-1);
			}

			page = 0xf0;	/* 1111---- */
			if( stricmp( bf[2], "out" ) == 0 ) {
// out   ch  on/off/toggle [input_off/input_on] [p1/p12/p123/...] [alias x]
				ch = -1;
				mode = -1;
				input_flg = 0;
				for( n=3; n<rc; n++ ) {
					if( isdigit(*bf[n]) ) {
						sscanf( bf[n], "%d", &ch );
						if( ch < 1 || ch > 4 ) {
							msg = "out ch";
							rc = -1;
							break;
						}
						ch--;		/* 1-4 -> 0-3 */
					} else if( stricmp( bf[n], "toggle" ) == 0 ) {
						mode = 0;
					} else if( stricmp( bf[n], "on" ) == 0 ) {
						mode = 1;
					} else if( stricmp( bf[n], "off" ) == 0 ) {
						mode = 2;
					} else if( stricmp( bf[n], "input_on" ) == 0 ) {
						input_flg = 1;
					} else if( stricmp( bf[n], "input_off" ) == 0 ) {
						input_flg = 2;
					} else if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "out option";
						rc = -1;
						break;
					}
				}
				if( ch == -1 || mode == -1 ) {
					msg = "out format";
					rc = -1;
				}
				if( rc != -1 ) {
// AAAAIIII  C-MMMMNN      AAAA:Page,IIII:ID1,C:0-1,MMMM:(),NN:0-3
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_PORT;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] |= ((mode + (input_flg*3)) << 2);
				}
			} else if( stricmp( bf[2], "page" ) == 0 ) {
// page  pg/up/down [p1/p12/p123/...] [alias x]
				ch = -1;
				for( n=3; n<rc; n++ ) {
					if( isdigit(*bf[n]) ) {
						sscanf( bf[n], "%d", &ch );
						if( ch < 1 || ch > 4 ) {
							msg = "page";
							rc = -1;
							break;
						}
					} else if( stricmp( bf[n], "up" ) == 0 ) {
						ch = 5;
					} else if( stricmp( bf[n], "down" ) == 0 ) {
						ch = 6;
					} else if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "page option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  -----NNN      AAAA:Page,IIII:ID1,NNN:(0-2,3:up,4:down)
				if( rc == -1 ) {
					msg = "page format";
					rc = -1;
				} else {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_PAGE;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch-1;
				}
			} else if( stricmp( bf[2], "time_adjust" ) == 0 ) {
// time_adjust  [p1/p12/p123/...] [alias x]
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "time_adjust option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  --------      AAAA:Page,IIII:ID1
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_ADJUST;
				}
			} else if( stricmp( bf[2], "alarm_mode" ) == 0 ) {
// alarm_mode toggle/on/off [p1/p12/p123/...] [alias x]
				ch = -1;
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "toggle" ) == 0 ) {
						ch = 0;
					} else if( stricmp( bf[n], "on" ) == 0 ) {
						ch = 1;
					} else if( stricmp( bf[n], "off" ) == 0 ) {
						ch = 2;
					} else if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "alarm_mode option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  ------NN      AAAA:Page,IIII:ID1,NN:(0:toggle,1:on,2:off)
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_ALARM_MODE;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch;
				}
			} else if( stricmp( bf[2], "convert" ) == 0 ) {
// convert [int] outdatafile.dat 0-15 [p1/p12/p123/...] [alias x]
				ch = -1;
				ext_int = 0;
				target_file = NULL;
				for( n=3; n<rc; n++ ) {
					if( isdigit(*bf[n]) ) {
						sscanf( bf[n], "%d", &ch );
						if( ch < 0 || ch > 15 ) {
							msg = "convert";
							rc = -1;
							break;
						}
					} else if( stricmp( bf[n], "int" ) == 0 ) {
						ext_int = 1;
					} else if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
//printf( "<<%02X:%02X>>\n", alias[ 0 ], alias[ 1 ] );
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else if( isalnum( *bf[n] ) ) {
						target_file = bf[n];
					} else {
						msg = "convert option";
						rc = -1;
						break;
					}
				}
				if( target_file == NULL ) {
					msg = "convert option";
					rc = -1;
				}
				if( rc != -1 ) {
// AAAAIIII  C--MNNNN      AAAA:Page,IIII:ID1,C:0-1,M:(0:ext,1:int),NNNN:0-15
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_CONVERT;
					if( ext_int ) {
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = 0x10;
					} else {
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = 0x00;
					}
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] |= ch;
					/* f[^ŵ߃f[^ւ̃AhXL^ */
					sz = fsize( target_file );	/* t@CTCY𒲂ׂ */
					if( ext_int == 0 ) {
						/* ext */
						fname_flg[cnt_total] = 0;
						strcpy( fname_data_ptr[cnt_total], target_file );
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = ext_adr>>8;
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+5] = ext_adr&0xff;
						if( sz == -1 ) {
							fclose( fp );
							printf( "File size get error.[%s]\n", fname_data_ptr[cnt_total] );
							return(-1);
						} else {
							ext_adr += sz;
						}
					} else {
						/* int */
						fname_flg[cnt_total] = 1;
						strcpy( fname_data_ptr[cnt_total], target_file );
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = int_adr>>8;
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+5] = int_adr&0xff;
						if( sz == -1 ) {
							fclose( fp );
							printf( "File size get error.[%s]\n", fname_data_ptr[cnt_total] );
							return(-1);
						} else {
							int_adr += sz;
						}
					}
				}
			} else if( stricmp( bf[2], "time" ) == 0 ) {
// time [week] [p1/p12/p123/...] [alias x]
				ch = 0;
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( strlen(bf[n]) == 3 && toupper(*bf[n]) == 'C'
							&& strchr("01234",bf[n][1]) != NULL && strchr("01234",bf[n][2]) != NULL ) {
						wk1 = bf[n][1]-'0';
						wk2 = bf[n][2]-'0';
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = 0;
						if( wk1 ) {
							wk1--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= (1<<wk1)<<4;
						}
						if( wk2 ) {
							wk2--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= 1<<wk2;
						}
					} else if( stricmp( bf[n], "week" ) == 0 ) {
						ch = 1;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "time option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  -------N      AAAA:Page,IIII:ID1,N:(0:every,1:week)
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_TIME;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch;
				}
			} else if( stricmp( bf[2], "sampling" ) == 0 ) {
// sampling     [p1/p12/p123/...] [alias x]
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "sampling option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  --------      AAAA:Page,IIII:ID1
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_SAMPLING;
				}
			} else if( stricmp( bf[2], "rs232c" ) == 0 ) {
// rs232c       [p1/p12/p123/...] [alias x]
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "rs232c option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  --------      AAAA:Page,IIII:ID1
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_RS232C;
				}
			} else if( stricmp( bf[2], "Alarm" ) == 0 ) {
// alarm [week] [once] [p1/p12/p123/...] [alias x]
				ch = 0;
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( strlen(bf[n]) == 3 && toupper(*bf[n]) == 'C'
							&& strchr("01234",bf[n][1]) != NULL && strchr("01234",bf[n][2]) != NULL ) {
						wk1 = bf[n][1]-'0';
						wk2 = bf[n][2]-'0';
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = 0;
						if( wk1 ) {
							wk1--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= (1<<wk1)<<4;
						}
						if( wk2 ) {
							wk2--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= 1<<wk2;
						}
					} else if( stricmp( bf[n], "once" ) == 0 ) {
						ch |= 2;
					} else if( stricmp( bf[n], "week" ) == 0 ) {
						ch |= 1;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "AlarmSet option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  ------MN      AAAA:Page,IIII:ID1,M:(0:repeat,1:once),N:(0:every,1:week)
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_ALARM;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch;
				}
			} else if( stricmp( bf[2], "Number" ) == 0 ) {
// number  num  [p1/p12/p123/...] [alias x]
				for( n=3; n<rc; n++ ) {
					if( isdigit(*bf[n]) ) {
						sscanf( bf[n], "%d", &ch );
						if( ch < 0 || ch > 9 ) {
							msg = "num";
							rc = -1;
							break;
						}
					} else if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "TimerSet option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  ----NNNN      AAAA:Page,IIII:ID1,NNNN:0-9
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_NUMBER;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch;
				}
			} else if( stricmp( bf[2], "Timer" ) == 0 ) {
// timer        [p1/p12/p123/...] [alias x]
				for( n=3; n<rc; n++ ) {
					if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else if( strlen(bf[n]) == 3 && toupper(*bf[n]) == 'C'
							&& strchr("01234",bf[n][1]) != NULL && strchr("01234",bf[n][2]) != NULL ) {
						wk1 = bf[n][1]-'0';
						wk2 = bf[n][2]-'0';
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = 0;
						if( wk1 ) {
							wk1--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= (1<<wk1)<<4;
						}
						if( wk2 ) {
							wk2--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= 1<<wk2;
						}
					} else if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else {
						msg = "TimerSet option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  --------      AAAA:Page,IIII:ID1
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_TIMER;
				}
			} else if( stricmp( bf[2], "alarm_reset" ) == 0 ) {
// alarm_reset  [p1/p12/p123/...] [alias x]
				for( n=3; n<rc; n++ ) {
					if( stricmp( bf[n], "alias" ) == 0 && (n+1) < rc ) {
						n++;
						sscanf( bf[n], "%d", &alias_num );
						if( alias_num < 1 || alias_num > ALIAS_MAX ) {
							msg = "alias range over";
							rc = -1;
							break;
						}
						alias[ ee_image[0]*2    ] = (ee_image[code_cnt*5+2] *6+page_top) & 0xff;
						alias[ ee_image[0]*2 +1 ] = (((ee_image[code_cnt*5+2] *6+page_top) >> 1) & 0x80) | alias_num;
						ee_image[0]++;
					} else if( strlen(bf[n]) == 3 && toupper(*bf[n]) == 'C'
							&& strchr("01234",bf[n][1]) != NULL && strchr("01234",bf[n][2]) != NULL ) {
						wk1 = bf[n][1]-'0';
						wk2 = bf[n][2]-'0';
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = 0;
						if( wk1 ) {
							wk1--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= (1<<wk1)<<4;
						}
						if( wk2 ) {
							wk2--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= 1<<wk2;
						}
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "alarm_reset option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  --------      AAAA:Page,IIII:ID1
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_ALARM_RESET;
				}
			} else if( stricmp( bf[2], "alias" ) == 0 ) {
// alias [num] [p1/p12/p1234/...] [alias x]...[alias x]
				ch = 0;
				for( n=3; n<rc; n++ ) {
					if( isdigit(*bf[n]) ) {
						sscanf( bf[n], "%d", &ch );
						if( ch < 0 || ch > ((512-20)/6) ) {
							msg = "alias";
							rc = -1;
							break;
						}
					} else if( strlen(bf[n]) == 3 && toupper(*bf[n]) == 'C'
							&& strchr("01234",bf[n][1]) != NULL && strchr("01234",bf[n][2]) != NULL ) {
						wk1 = bf[n][1]-'0';
						wk2 = bf[n][2]-'0';
						ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] = 0;
						if( wk1 ) {
							wk1--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= (1<<wk1)<<4;
						}
						if( wk2 ) {
							wk2--;
							ee_image[ ee_image[code_cnt*5+2] *6+page_top+4] |= 1<<wk2;
						}
					} else if( (tmp_num = PageGet( bf[n] )) != -1 ) {
						page = tmp_num<<4;
					} else {
						msg = "alias option";
						rc = -1;
						break;
					}
				}
// AAAAIIII  -NNNNNNN    AAAA:Page,IIII:ID1,NNNNNNN:num
				if( rc != -1 ) {
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+0] = buf2[2];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+1] = buf2[3];
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+2] = page | EV_ALIAS;
					ee_image[ ee_image[code_cnt*5+2] *6+page_top+3] = ch;
				}
			} else {
				msg = "unknown format";
				rc = -1;
			}
			if( rc == -1 ) {
				fclose( fp );
				printf( "File format error." );
				if( *msg ) {
					printf( "[%s]", msg );
				}
				printf( "\n" );
				printf( "> %s", buff );
				return(-1);
			}
			 ee_image[code_cnt*5+2] ++;
			 cnt_total++;
		}
	}
	fclose( fp );

	/* gpTCYvZ */
	use_int_rom = cnt_total*6+20 + ee_image[0]*2 + int_adr;
	if( use_int_rom > 512 ) {
		printf( "Internal EEPROM overflow!\n" );
		return(-1);
	}
//	if( ext_adr >= 8192L ) {	/* 24LC64 */
	if( ext_adr >= 32768L ) {	/* 24LC256 */
		printf( "External EEPROM overflow!\n" );
		return(-1);
	}

	if( ee_image[0] ) {
		/* aliasgĂꍇ̓f[^Vtg */
		for( n=0; n<3; n++ ) {
			if( ee_image[n*5+7] ) {
				/* EEPROMgϊ[h */
				new_adr = (int)(ee_image[n*5+8]<<8)|ee_image[n*5+9];
				new_adr += (ee_image[0]*2);
				ee_image[n*5+8] = new_adr>>8;
				ee_image[n*5+9] = new_adr&0xff;
			}
		}
		for( n=511; n>=(20+ee_image[0]*2); n-- ) {
			ee_image[n] = ee_image[n-ee_image[0]*2];
		}
// A~𐳂ʂĂȂ̂memcpy̓[NGApӂȂƕs
//		memcpy( &ee_image[20+ee_image[0]*2], &ee_image[20], 512-(20+ee_image[0]*2) );
		memcpy( &ee_image[20], alias, ee_image[0]*2 );
		/* AhXItZbg */
		for( n=0; n<ee_image[0]; n++ ) {
			adr = n*2+20;
			new_adr = (int)ee_image[adr]|(int)(ee_image[adr+1]&0x80)<<1;
			new_adr += (ee_image[0]*2);
			ee_image[adr] = new_adr&0xff;
			ee_image[adr+1] |= (new_adr>>1)&0x80;
		}
	}

	if( int_adr ) {
		/* EEPROMgĕϊ[h𗘗pꍇ */
		/* AhXItZbg */
		for( n=0; n<cnt_total; n++ ) {
			adr = n*6+20+ee_image[0]*2;
			if( fname_flg[n] == 1 ) {
				/* EEPROMgϊ[h */
				new_adr = (int)(ee_image[adr+4]<<8)|ee_image[adr+5];
				new_adr += (cnt_total*6+20+ee_image[0]*2);
				ee_image[adr+4] = new_adr>>8;
				ee_image[adr+5] = new_adr&0xff;
			}
		}
		/* t@Cǂݍ݁AEEPROM[C[Wɏ */
		adr = cnt_total*6+20+ee_image[0]*2;
		for( n=0; n<cnt_total; n++ ) {
			if( fname_flg[n] != 1 ) {
				continue;	/* ȊO͑ΏۊO */
			}
			if( (fp=fopen(fname_data_ptr[n],"rb")) == NULL ) {
				printf( "File open error[%s].\n", fname_data_ptr[n] );
				return(-1);
			}
			while( (dt=fgetc(fp)) >= 0 ) {
				ee_image[adr] = (char)dt;
				adr++;
			}
			fclose(fp);
		}
	}

	if( Debug ) {
		int	x, y;

		for( x=0; x<20; x++ ) {
			if( (x % 5) == 0 ) {
				printf( "%04X : ", x );
			}
			printf( "%02X ", ee_image[x] );
			if( (x % 5) == 4 ) {
				printf( "\n" );
			}
		}
		for( x=20, y=0; x<(20+ee_image[0]*2); x+=2, y++ ) {
			printf( "%04X : ", x );
			printf( "%02X %02X\n", ee_image[x], ee_image[x+1] );
		}
		for( x=(20+ee_image[0]*2), y=0; x<cnt_total*6+20+ee_image[0]*2; x++, y++ ) {
			if( (y % 6) == 0 ) {
				printf( "%04X : ", x );
			}
			printf( "%02X ", ee_image[x] );
			if( (y % 6) == 5 ) {
				printf( "\n" );
			}
		}
		for( x=cnt_total*6+20+ee_image[0]*2, y=0; x<use_int_rom; x++, y++ ) {
			if( (y % 16) == 0 ) {
				printf( "%04X : ", x );
			}
			printf( "%02X ", ee_image[x] );
			if( (y % 16) == 15 ) {
				printf( "\n" );
			}
		}
		printf( "\n" );
		printf( "Test end.\n" );
		return(-1);
	}

	/* EEPROM݃[hֈڍs */
	/* E -> E*/
	if( RsSendAndWait( ComPort, "E", 1, 'E', 2000, NULL ) != 0 ) {
		return(-1);
	}


#define	TRANS_STEP	128

	/* ee_imagȅݏ */
printf( "EEPROM writing(internal).\n" );
	for( n=0; n<use_int_rom; n+=TRANS_STEP ) {
		m = (n+TRANS_STEP) > use_int_rom ? use_int_rom : n+TRANS_STEP;
		/* EEPROM */
		if( ERS_Send( ComPort, "w", 1 ) != 1 ) {
			printf( "COM send1() error.\n" );
			return(-1);
		}
		Sleep(1);
		/* AhXM(2byte) */
		buf2[0] = n>>8;
		if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		buf2[0] = n&0xff;
		if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		/* f[^M(1byte) */
		buf2[0] = m-n;
		if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
			printf( "COM send3() error.\n" );
			return(-1);
		}
		Sleep(1);

		/* f[^M */
		for( i=n; i<m; i++ ) {
printf("%d/512 byte\r", i );
			if( ERS_Send( ComPort, &ee_image[i], 1 ) != 1 ) {
				printf( "COM send4() error.\n" );
				return(-1);
			}
			Sleep(1);
		}
		/* ݊҂ */
		/* wait w */
		if( RsSendAndWait( ComPort, NULL, 0, 'w', 10000, NULL ) != 0 ) {
			return(-1);
		}
	}
printf("\n\n" );

	/* OEEPROM̏ݏ */
	if( ext_adr ) {
printf( "EEPROM writing(external).\n" );
		if( FileReadInit( fname_data_ptr, fname_flg, cnt_total ) != 0 ) {
			printf( "FileReadInit() error!\n" );
			return(-1);
		}
	}

	for( n=0; n<ext_adr; n+=TRANS_STEP ) {
		m = (n+TRANS_STEP) > ext_adr ? ext_adr : n+TRANS_STEP;
		if( ERS_Send( ComPort, "W", 1 ) != 1 ) {
			printf( "COM send() error.\n" );
			return(-1);
		}
		Sleep(1);
		/* AhXM(2byte) */
		buf2[0] = n>>8;
		if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		buf2[0] = n&0xff;
		if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		/* f[^M(1byte) */
		buf2[0] = m-n;
		if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
			printf( "COM send3() error.\n" );
			return(-1);
		}
		Sleep(1);

		/* f[^M */
		for( i=n; i<m; i++ ) {
printf("%d/32768 byte\r", i );
			dt = FileReadChar();
			if( dt < 0 ) {
				printf( "FileReadChar() error!\n" );
				return(-1);
			}
			buf2[0] = (unsigned char)dt;
			if( ERS_Send( ComPort, buf2, 1 ) != 1 ) {
				printf( "COM send4() error!\n" );
				return(-1);
			}
			Sleep(1);
		}
		/* ݊҂ */
		/* wait W */
		if( RsSendAndWait( ComPort, NULL, 0, 'W', 10000, NULL ) != 0 ) {
			return(-1);
		}
	}

	if( ext_adr ) {
printf("\n\n" );
		FileReadEnd();
	}

	/* EEPROM݃[hI */
	if( RsSendAndWait( ComPort, "c", 1, 'Y', 2000, NULL ) != 0 ) {
		return(-1);
	}
#if 0
	/* EEPROM̂݃xt@C */
	for( n=0; n<int_adr; n++ ) {
		sprintf( buf2, "%04X", n );
		if( ERS_Send( ComPort, "h", 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		if( ERS_Send( ComPort, &buf2[0], 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		if( ERS_Send( ComPort, &buf2[1], 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		if( ERS_Send( ComPort, &buf2[2], 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		Sleep(1);
		if( ERS_Send( ComPort, &buf2[3], 1 ) != 1 ) {
			printf( "COM send2() error.\n" );
			return(-1);
		}
		if( (buf2[5]=RsRecAndWait( ComPort, 2000 )) == -1 ) {
			return(-1);
		}
		if( ee_image[n] != buf2[5] ) {
			printf( "%s : %02X - %02X\n", buf2, ee_image[n], buf2[5] );
		}
	}
#endif

	return(0);
}

int	DataSendNecTcp( int fh, char *fname )
{
	return(0);
}

int	DataSendTcp( int fh, char *fname )
{
	int		n, len;
	int		dt;
	unsigned	char	uch, buf[10];
	FILE	*fp;

	if( (fp=fopen(fname,"rb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

	/* Mw */
	if( tcp_send( fh, "s", 1 ) != 0 ) {
		fclose( fp );
		printf( "TCP send() error.\n" );
		return(-1);
	}

	for( n=20; n>0; n-- ) {
		if( tcp_data_length( fh, &len ) != -1 ) {
			if( tcp_rec( fh, (char *)buf, 1 ) == 0 ) {
				if( *buf == 'S' ) {
					break;
				}
			}
		}
		Sleep(100);
	}
	if( n == 0 ) {
		fclose( fp );
		printf( "Device is not ready.\n" );
		return(-1);
	}

	/* f[^M */
	while( (dt=fgetc(fp)) != EOF ) {
		uch = (unsigned char)dt;
		if( tcp_send( fh, &uch, 1 ) != 0 ) {
			fclose( fp );
			printf( "TCP send() error.\n" );
			return(-1);
		}
		Sleep(1);
	}
	fclose( fp );

	for( n=20; n>0; n-- ) {
		if( tcp_data_length( fh, &len ) != -1 ) {
			if( tcp_rec( fh, (char *)buf, 1 ) == 0 ) {
				if( *buf == 'E' ) {
					break;
				}
			}
		}
		Sleep(100);
	}
	if( n == 0 ) {
		printf( "Device is not ready.\n" );
		return(-1);
	}
	return(0);
}

int	DataReceiveTcp( int fh, char *fname )
{
	int		n;
	int		len;
	int		cnt;
	int		dt;
	FILE	*fp;
	unsigned	char	buf[10];

	if( (fp=fopen(fname,"wb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

	/* Mw */
	if( tcp_send( fh, "R", 1 ) != 0 ) {
		printf( "TCP send() error.\n" );
		fclose( fp );
		return(-1);
	}
	for( n=20; n>0; n-- ) {
		if( tcp_data_length( fh, &len ) != -1 ) {
			if( tcp_rec( fh, (char *)buf, 1 ) == 0 ) {
				if( *buf == 'Y' ) {
					break;
				}
			}
		}
		Sleep(100);
	}
	if( n == 0 ) {
		fclose( fp );
		printf( "Device is not ready.\n" );
		return(-1);
	}

	printf( "Hit [ESC] to break.\n" );

	cnt = 0;
	for( n=600; n>0; n-- ) {
		if( kbhit() ) {
			dt = getch();
			if( dt == 0x1b ) {
				if( tcp_send( fh, "c", 1 ) != 0 ) {
					fclose( fp );
					printf( "TCP send() error.\n" );
					return(-1);
				}
				printf("Receive Cancel!\n");
				fclose( fp );
				return(0);
			}
		}

		if( tcp_data_length( fh, &len ) != -1 ) {
			if( tcp_rec( fh, (char *)buf, 1 ) == 0 ) {
				if( cnt == 0 ) {
					if( *buf == 'S' ) {
						printf("Receive Start!\n");
						cnt++;
						continue;
					} else {
						n = 0;
						break;
					}
				}
				cnt++;
				if( cnt == 3 ) {
					len = (unsigned int)*buf;
					len <<= 8;
				} else if( cnt == 4 ) {
					len += (unsigned int)*buf;
				} else if( cnt > 4 ) {
					if( cnt >= (1+3+len+1) && *buf == 'E' ) {
						n = 600;
						break;
					}
				}
				fputc( *buf, fp );
				n = 600;
				continue;
			}
		}
		Sleep(100);
	}
	if( n == 0 ) {
		fclose( fp );
		printf( "TCP receive() timeout.\n" );
		return(-1);
	}
	fclose( fp );
	return(0);
}

int	InData( void )
{
	int		n;
	int		dt;
	int		len;
	unsigned	char	buf[10];

	//Mobt@̃NA
	ERS_ClearRecv( ComPort );
	//Mobt@̃NA
	ERS_ClearSend( ComPort );

	/* Mw */
	if( RsSendAndWait( ComPort, "R", 1, 'Y', 2000, NULL ) != 0 ) {
		return(-1);
	}
	
	
	
	
	
	
	
	return(*buf);
}

int	InDataTcp( int in_port )
{
	TCPSERVER_INFO	server;
	TCPCLIENT_INFO	client1, data[5];
	int		n;
	int		dt;
	int		len;
	unsigned	char	buf[10];

	tcpserver_init(&server, htonl(SERVER_IP), in_port);
	/* socket(), bind(), listen()R[ */
	if( tcpserver_open(&server,0) ) {
		/* C[v */
		while(tcpserver_wait(&server, &client1,0)) {   /* NCAgڑ҂ */
			/* NCAgڑꂽ */
			
			
			
			
			
		}
	}
#if 0
	/* socket(), bind(), listen()R[ */
	if( tcpserver_open(&server,0) ) {
		/* C[v */
		while(tcpserver_wait(&server, &client1,0)) {   /* NCAgڑ҂ */
			/* NCAgڑꂽ */
			if( mode == 1 ) {
#ifdef	WINDOWS
				CreateThread(0, 0, portfw_thread, (void*)client1.data_socket, 0, &nThreadID);
#else
				pthread_create( &t1, NULL, portfw_thread, (void *)client1.data_socket );
				pthread_detach(t1);
#endif
			} else if( mode == 2 ) {
				for(;;) {
					/* f[^ʐMp|[gɐڑ */
					data.client1.data_socket = client1.data_socket;
					if( (data.client2.data_socket = tcp_connect( out_host, out_port )) < 0 ) {
						tcpclient_close(&client1);
						break;
					}
#ifdef	WINDOWS
					CreateThread(0, 0, relay_thread_sub, (void*)&data, 0, &nThreadID);
#else
					pthread_create( &t1, NULL, relay_thread_sub, (void *)&data );
					pthread_detach(t1);
#endif
					break;
				}
			}
			client1.data_socket = -1;
		}
	}

	/* T[ȍI */
	tcpserver_close(&server);

#endif



#if 0
	/* Mw */
	if( tcp_send( fh, "r", 1 ) != 0 ) {	/******************/
		printf( "TCP send() error.\n" );
		return(-1);
	}
	for( n=20; n>0; n-- ) {
		if( tcp_data_length( fh, &len ) != -1 ) {
			if( tcp_rec( fh, (char *)buf, 1 ) == 0 ) {
				if( *buf == 'R' ) {
					break;
				}
			}
		}
		Sleep(100);
	}
	if( n == 0 ) {
		printf( "Device is not ready.\n" );
		return(-1);
	}
#endif
	
	
	
	
	return(*buf);
}


void	help( void )
{
#ifdef	WINDOWS
	printf( "> com -s -c comport -f datafile  (send)\n" );
	printf( "> com -r -c comport -f datafile  (receive)\n" );
#endif
	printf( "> com -v            -f datafile  (view)\n" );
/*	printf( "> com -s -c comport -n number\n" );	*/
/*	printf( "> com -s -h server -p port -f datafile\n" );	*/
	printf( "> com -d -c comport -f datafile  (send by code)\n" );
	printf( "> com -e -c comport -f conffile  (write eeprom)\n" );
	printf( "> com -m            -f datafile  (make datafile by code)\n" );
/*	printf( " <common option> -S57600/-S115200\n" );	*/
#ifdef	WINDOWS
/*	printf( "> com -i -c comport\n" );	*/
#endif
/*	printf( "> com -i -h server -p port\n" );	*/
}

int	ParamCheck( int ar, char *av[] )
{
	int		n;

	Mode = -1;
	DataFile = NULL;
	Server = NULL;
	ComPort = -1;
	TcpPort = -1;

	for( n=1; n<ar; n++ ) {
		if( stricmp( av[n], "-s" ) == 0 ) {
			Mode = 's';	/* s:send,r:receive,v:view,i:inport,d:send(NEC),e:eeprom,m:make */
		} else if( stricmp( av[n], "-r" ) == 0 ) {
			Mode = 'r';
		} else if( stricmp( av[n], "-v" ) == 0 ) {
			Mode = 'v';
		} else if( stricmp( av[n], "-i" ) == 0 ) {
			Mode = 'i';
		} else if( stricmp( av[n], "-d" ) == 0 ) {
			Mode = 'd';
		} else if( stricmp( av[n], "-e" ) == 0 ) {
			Mode = 'e';
		} else if( stricmp( av[n], "-m" ) == 0 ) {
			Mode = 'm';
		} else if( stricmp( av[n], "-g" ) == 0 ) {
			Debug = 1;
		} else if( stricmp( av[n], "-c" ) == 0 ) {
			if( n+1 == ar ) {
				printf( "Option error.<-c>\n" );
				return(-1);
			}
			if( isdigit(*av[n+1]) ) {
				sscanf( av[n+1], "%d", &ComPort );
			} else {
				ComPort = ComGetPort( 2, av[n+1] );
			}
			n++;
		} else if( stricmp( av[n], "-p" ) == 0 ) {
			if( n+1 == ar ) {
				printf( "Option error.<-p>\n" );
				return(-1);
			}
			if( isdigit(*av[n+1]) ) {
				sscanf( av[n+1], "%d", &TcpPort );
			} else {
				printf( "Option error.<-p>\n" );
				return(-1);
			}
			n++;
		} else if( stricmp( av[n], "-f" ) == 0 ) {
			if( n+1 == ar ) {
				printf( "Option error.<-f>\n" );
				return(-1);
			}
			DataFile = av[n+1];
			n++;
		} else if( stricmp( av[n], "-h" ) == 0 ) {
			if( n+1 == ar ) {
				printf( "Option error.<-t>\n" );
				return(-1);
			}
			Server = av[n+1];
			n++;
		} else {
			printf( "Option error.<?>\n" );
			return(-1);
		}
	}

	/* s:send,r:receive,v:view,i:inport,d:send(NEC),e:eeprom,m:make */
	if( Mode == -1 ) {
		printf( "Option error.<?>\n" );
		return(-1);
	}
	/* eweɍ킹ăp[^`FbN */
	if( Mode == 's' || Mode == 'r' || Mode == 'i' || Mode == 'd' || Mode == 'e' ) {
		if( ComPort == -1 && TcpPort == -1 ) {
			printf( "port error.\n" );
			return(-1);
		}
		if( TcpPort == -1 ) {
			if( ComPort < 1 || ComPort > 255 ) {
				printf( "COM port error.<%d>\n", ComPort );
				return(-1);
			}
		} else {
			if( TcpPort < 1024 || TcpPort > 65535 ) {
				printf( "TCP port error.<%d>\n", TcpPort );
				return(-1);
			}
			if( Server == NULL ) {
				printf( "TCP server error.\n" );
				return(-1);
			}
		}
	}
	if( Mode == 's' || Mode == 'r' || Mode == 'v' || Mode == 'd' || Mode == 'e' || Mode == 'm' ) {
		if( DataFile == NULL ) {
			if( Mode == 'e' || Mode == 'm' ) {
				printf( "Config file error.\n" );
			} else {
				printf( "Data file error.\n" );
			}
			return(-1);
		}
	}
	return(0);
}

int	ViewCode( int len, unsigned char *buf, int set_max, unsigned char *setbuf )
{
#define	BIT(n,bit)	(buf[n] & (1<<bit))
	unsigned	char	bit, bit_out, data_out;
	unsigned	char	stat;
	int		n, H, L, base, base3;
	int		bit_count;

	stat = 0;
	base = 0;
	bit_out = 7;
	data_out = 0;
	bit_count = 0;
	for( n=0; n<len; n++ ) {
		for( bit=0; bit<8; bit++ ) {
			if( stat == 2 ) {			/* Data read H */
				if( BIT(n,bit) ) {
					H++;
				} else {
					if( base == 0 ) {
						base = H + (H>>1);
						base3 = base + base + base;
					}
					stat++;
					L = 0;
				}
			} else if( stat == 3 ) {	/* Data read L */
				if( !BIT(n,bit) ) {
					L++;
					if( base3 < L ) {
						if( set_max < (bit_count>>3) ) {
							return(0);
						}
						setbuf[bit_count>>3] = data_out;
						return(bit_count);
					}
				} else {
					if( base < L ) {
						data_out |= (1<<bit_out);
					}
					if( bit_out == 0 ) {
						bit_out = 7;
						if( set_max < (bit_count>>3) ) {
							return(0);
						}
						setbuf[bit_count>>3] = data_out;
						data_out = 0;
					} else {
						bit_out--;
					}
					stat--;
					H = 0;
					bit_count++;
				}
			} else if( stat == 0 ) {	/* Header-H skip */
				if( !BIT(n,bit) ) {
					stat++;
				}
			} else if( stat == 1 ) {	/* Header-L skip */
				if( BIT(n,bit) ) {
					stat++;
					H = 0;
				}
			}
		}
	}
	return(bit_count);
}

int	ViewFile( char *fname )
{
	int		n, bit;
	int		len;
	int		dt;
	FILE	*fp;
	unsigned	char	uch, buf[1024], buf2[1024];
	int		bit_count;

	if( (fp=fopen(fname,"rb")) == NULL ) {
		printf( "File open error.\n" );
		return(-1);
	}

	/* TvOǂݏo */
	if( (dt=fgetc(fp)) == EOF ) {
		printf( "File read error.\n" );
		fclose( fp );
		return(-1);
	}

	if( dt == 0xff ) {
		/* obt@[݊f[^ƋIɔ */
		printf( "obt@[݊[hf[^\n" );
		rewind( fp );
		/* f[^ǂݏo */
		for( n=0; n<240; n++ ) {
			if( (dt=fgetc(fp)) == EOF ) {
				printf( "File read error.\n" );
				fclose( fp );
				return(-1);
			}
			buf[n] = dt;
			uch = (unsigned char)dt;
			for( bit=0; bit<8; bit++ ) {
				if( uch & (1<<bit) ) {
					printf( "H" );
				} else {
					printf( "_" );
				}
			}
		}
		fclose( fp );
		bit_count = ViewCode( 240, buf, 8, buf2 );
printf( "\n" );
		for( n=0; n<(bit_count+7)/8; n++ ) {
printf( "%02X ", buf2[n] );
		}
printf( "\nbit_count = %d\n", bit_count );
		return(0);
	}
	
	printf( "TvO:%d uS\n", dt );

	/* i[f[^TCYǂݏo */
	if( (len=fgetc(fp)) == EOF ) {
		printf( "File read error.\n" );
		fclose( fp );
		return(-1);
	}
	if( (dt=fgetc(fp)) == EOF ) {
		printf( "File read error.\n" );
		fclose( fp );
		return(-1);
	}
	len = (len<<8)|dt;
	printf( "f[^:%d byte\n", len );

	/* f[^ǂݏo */
	for( n=0; n<len; n++ ) {
		if( (dt=fgetc(fp)) == EOF ) {
			printf( "File read error.\n" );
			fclose( fp );
			return(-1);
		}
		buf[n] = dt;
		uch = (unsigned char)dt;
		for( bit=0; bit<8; bit++ ) {
			if( uch & (1<<bit) ) {
				printf( "H" );
			} else {
				printf( "_" );
			}
		}
	}
	fclose( fp );
	bit_count = ViewCode( len, buf, 8, buf2 );
printf( "\n" );
	for( n=0; n<(bit_count+7)/8; n++ ) {
printf( "%02X ", buf2[n] );
	}
printf( "\nbit_count = %d\n", bit_count );
	return(0);
}

int	main( int ar, char *av[] )
{
	int		rc;
	int		fh;

#ifdef	WINDOWS
	WORD	version;
	WSADATA	wsa;

	version = MAKEWORD(2,0);
	WSAStartup(version, &wsa);
#endif

	/* p[^擾 */
	if( ParamCheck( ar, av ) == -1 ) {
		help();
#ifdef	WINDOWS
		ComGetPort( 1, "" );
#endif
		return(1);
	}

	/* s:send,r:receive,v:view,i:inport,d:send(NEC),e:eeprom,m:make */
	if( Mode == 'v' ) {
		rc = ViewFile( DataFile );
#ifdef	WINDOWS
		WSACleanup();
#endif
		return(rc);
	}

	if( Mode == 'i' ) {
		if( TcpPort == -1 ) {
			rc = InData();
		} else {
			rc = InDataTcp( TcpPort );
		}
#ifdef	WINDOWS
		WSACleanup();
#endif
		return(rc);
	}

	/* s:send,r:receive,v:view,i:inport,d:send(NEC),e:eeprom,m:make */
	if( Mode == 'm' ) {
		if( MakeDataFile( DataFile ) == 0 ) {
			rc = 0;
			printf( "Make DataFile OK\n" );
		} else {
			rc = 1;
			printf( "Make DataFile NG\n" );
		}
		return(rc);
	}

	if( TcpPort == -1 ) {
		rc = ERS_Open( ComPort, 2048, 2048 );
		if( rc != 0 ) {
			/* |[gI[vُ */
			printf( "COM open() error.<%d:%d>\n", ComPort, rc );
			return(1);
		}
		ERS_Config( ComPort, ERS_115200 | ERS_1 | ERS_NO | ERS_8 | ERS_X_N );
	} else {
		fh = tcp_connect( Server, TcpPort );
		if( fh < 0 ) {
			printf( "TCP open() error.<%s:%d>\n", Server, TcpPort );
			return(1);
		}
	}

	if( Mode == 's' ) {
		if( TcpPort == -1 ) {
			if( DataSend( DataFile ) == 0 ) {
				rc = 0;
				printf( "Send OK\n" );
			} else {
				rc = 1;
				printf( "Send NG\n" );
			}
		} else {
			if( DataSendTcp( fh, DataFile ) == 0 ) {
				rc = 0;
				printf( "Send OK\n" );
			} else {
				rc = 1;
				printf( "Send NG\n" );
			}
		}
	/* s:send,r:receive,v:view,i:inport,d:send(NEC),e:eeprom,m:make */
	} else if( Mode == 'd' ) {
		if( TcpPort == -1 ) {
			if( DataSendNec( DataFile ) == 0 ) {
				rc = 0;
				printf( "Send OK\n" );
			} else {
				rc = 1;
				printf( "Send NG\n" );
			}
		} else {
			if( DataSendNecTcp( fh, DataFile ) == 0 ) {
				rc = 0;
				printf( "Send OK\n" );
			} else {
				rc = 1;
				printf( "Send NG\n" );
			}
		}
	} else if( Mode == 'e' ) {
		if( TcpPort == -1 ) {
			if( EepromMode( DataFile ) == 0 ) {
				rc = 0;
				printf( "EEPROM Write OK\n" );
			} else {
				rc = 1;
				printf( "EEPROM Write NG\n" );
			}
//		} else {
//			if( EepromModeTcp( fh, DataFile ) == 0 ) {
//				rc = 0;
//				printf( "EEPROM Write OK\n" );
//			} else {
//				rc = 1;
//				printf( "EEPROM Write NG\n" );
//			}
		}
	} else {
		if( TcpPort == -1 ) {
			if( DataReceive( DataFile ) == 0 ) {
				rc = 0;
				printf( "Receive OK\n" );
			} else {
				rc = 1;
				printf( "Receive NG\n" );
			}
		} else {
			if( DataReceiveTcp( fh, DataFile ) == 0 ) {
				rc = 0;
				printf( "Receive OK\n" );
			} else {
				rc = 1;
				printf( "Receive NG\n" );
			}
		}
	}

	if( TcpPort == -1 ) {
		//Mobt@̃NA
		ERS_ClearRecv( ComPort );
		//Mobt@̃NA
		ERS_ClearSend( ComPort );

		ERS_Close( ComPort );
	} else {
		tcp_disconnect(fh);
	}

#ifdef	WINDOWS
	WSACleanup();
#endif
	return(rc);
}
